/**
 */
package net.astah.stpa.stamp.provider;


import static java.util.Collections.singleton;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.CopyCommand.Helper;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemStyledLabelProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.dd.di.Diagram;
import net.astah.dd.di.edit.command.DiagramContext;
import net.astah.dd.di.util.DiagramElements;
import net.astah.emf.edit.command.DiagramCommandParameter;
import net.astah.emf.edit.command.DiagramCommands;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.command.STAMPModelCopyCommand;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.Element} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated NOT
 */
public class ElementItemProvider 
    extends STAMPItemProviderAdapter
    implements
        IItemColorProvider,
        IItemFontProvider,
        IItemStyledLabelProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ElementItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

        }
        return itemPropertyDescriptors;
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.ELEMENT__OWNED_NOTE);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns Element.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/Element"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_Element_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(Element.class)) {
            case STAMPPackage.ELEMENT__OWNED_NOTE:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.ELEMENT__OWNED_NOTE,
                 STAMPFactory.eINSTANCE.createNote()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPEditPlugin.INSTANCE;
    }

    @Override
    protected Command createCopyCommand(final EditingDomain domain, final Object context,
            final EObject owner, final Helper helper) {
        return new STAMPModelCopyCommand(domain, context, owner, helper, domain.getOptimizeCopy());
    }

    @Override
    protected Command factorPasteCommand(final EditingDomain domain, final Object context,
            CommandParameter commandParameter) {
        Object owner = commandParameter.getOwner();
        if (!(owner instanceof Element)) {
            return super.factorPasteCommand(domain, context, commandParameter);
        }

        Collection<?> collection = commandParameter.getCollection();
        if ((collection == null) || collection.isEmpty()) {
            final Object container = getContextualContainer(owner, domain, context);
            if (container == null) {
                return super.factorPasteCommand(domain, context, commandParameter);
            }
            // 文脈から決定したコンテナに対象オブジェクトをペーストするパラメータを構築する
            collection = singleton(owner);
            owner = container;
            commandParameter = new DiagramCommandParameter(context, owner,
                    commandParameter.getFeature(), commandParameter.getValue(), collection,
                    commandParameter.getIndex());
        }

        // 対象にステレオタイプ適用のモデルが存在しなかった場合
        return super.factorPasteCommand(domain, context, commandParameter);
    }

    protected EObject resolveEquivalentContainer(final EditingDomain domain, final Object context,
            final Element object) {
        final EObject eContainer = object.eContainer();
        if (eContainer == null) {
            // コピー対象の最上位要素の場合のみ文脈上のコンテナを利用する
            return getContextualContainer(object, domain, context);
        }
        final Object equivalent = DiagramCommands.resolveEquivalent(domain, context, eContainer);
        if (equivalent instanceof EObject) {
            return (EObject) equivalent;
        }
        return null;
    }

    protected EObject getContextualContainer(final Object object, final EditingDomain editingDomain,
            final Object context) {
        if (context != null) {
            final Diagram diagram = DiagramContext.getDiagram(context);
            return DiagramElements.getModelElement(diagram);
        }
        return null;
    }
}
