/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemStyledLabelProvider;

import net.astah.stpa.stamp.Component;
import net.astah.stpa.stamp.Feedback;
import net.astah.stpa.stamp.Link;
import net.astah.stpa.stamp.LinkEnd;
import net.astah.stpa.stamp.LinkableElement;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.Feedback} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FeedbackItemProvider extends SignalItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public FeedbackItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

        }
        return itemPropertyDescriptors;
    }

    /**
     * This returns Feedback.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/Feedback"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((Feedback)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_Feedback_type") :
            getString("_UI_Feedback_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @see STAMPItemProviderAdapter#getTableCellText(Object)
     * @generated NOT
     */
    @Override
    public String getTableCellText(Object object) {
        final Feedback feedback = (Feedback) object;
        final Link link = feedback.getLink();
        final LinkableElement source = link.getSource();
        final LinkableElement target = link.getTarget();
        if (source instanceof LinkEnd && target instanceof Component) {
            return getString("_UI_ComponentExtractingTable_input_text") + feedback.getName();
        } else if (source instanceof Component && target instanceof LinkEnd) {
            return getString("_UI_ComponentExtractingTable_output_text") + feedback.getName();
        }
        final String targetComponentName = target.getName();
        return feedback.getName() + " (To: " + targetComponentName + ")";
    }

    /**
     * @see IItemStyledLabelProvider#getStyledText(Object)
     * @generated NOT
     */
    @Override
    public String getStyledText(Object object) {
        final Feedback feedback = (Feedback) object;
        final Link link = feedback.getLink();
        final LinkableElement source = link.getSource();
        final LinkableElement target = link.getTarget();
        if (source instanceof LinkEnd && target instanceof Component) {
            return getString("_UI_ComponentExtractingTable_input_text") + feedback.getName();
        } else if (source instanceof Component && target instanceof LinkEnd) {
            return getString("_UI_ComponentExtractingTable_output_text") + feedback.getName();
        }
        final String targetComponentName = target.getName();
        return feedback.getName() + " (To: " + targetComponentName + ")";
    }

}
