/**
 */
package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.uml2.common.edit.command.SubsetAddCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetReplaceCommand;
import org.eclipse.uml2.common.edit.command.SubsetSupersetSetCommand;
import org.eclipse.uml2.common.edit.command.SupersetRemoveCommand;

import net.astah.stpa.stamp.HCFAnalysisResult;
import net.astah.stpa.stamp.STAMPPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.HCFAnalysisResult} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HCFAnalysisResultItemProvider extends ElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFAnalysisResultItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addResultElementPropertyDescriptor(object);
            addHazardCausalFactorPropertyDescriptor(object);
            addUnsafeControlActionPropertyDescriptor(object);
            addHintWordPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Result Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addResultElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFAnalysisResult_resultElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFAnalysisResult_resultElement_feature", "_UI_HCFAnalysisResult_type"),
                 STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Hazard Causal Factor feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addHazardCausalFactorPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFAnalysisResult_hazardCausalFactor_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFAnalysisResult_hazardCausalFactor_feature", "_UI_HCFAnalysisResult_type"),
                 STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Unsafe Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addUnsafeControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFAnalysisResult_unsafeControlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFAnalysisResult_unsafeControlAction_feature", "_UI_HCFAnalysisResult_type"),
                 STAMPPackage.Literals.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Hint Word feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addHintWordPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFAnalysisResult_hintWord_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFAnalysisResult_hintWord_feature", "_UI_HCFAnalysisResult_type"),
                 STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HINT_WORD,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns HCFAnalysisResult.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/HCFAnalysisResult"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_HCFAnalysisResult_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createAddCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection, int)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR) {
            return new SubsetAddCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, collection, index);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetAddCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, collection, index);
        }
        return super.createAddCommand(domain, owner, feature, collection, index);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createRemoveCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SupersetRemoveCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, collection);
        }
        return super.createRemoveCommand(domain, owner, feature, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createReplaceCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object, java.util.Collection)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createReplaceCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value, Collection<?> collection) {
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value, collection);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value, collection);
        }
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SubsetSupersetReplaceCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, value, collection);
        }
        return super.createReplaceCommand(domain, owner, feature, value, collection);
    }

    /**
     * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#createSetCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.ecore.EObject, org.eclipse.emf.ecore.EStructuralFeature, java.lang.Object)
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected Command createSetCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Object value) {
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value);
        }
        if (feature == STAMPPackage.Literals.ELEMENT__OWNED_NOTE) {
            return new SubsetSupersetSetCommand(domain, owner, feature, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT}, null, value);
        }
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__RESULT_ELEMENT) {
            return new SubsetSupersetSetCommand(domain, owner, feature, null, new EStructuralFeature[] {STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR, STAMPPackage.Literals.ELEMENT__OWNED_NOTE}, value);
        }
        return super.createSetCommand(domain, owner, feature, value);
    }

    /**
     * @generated NOT
     */
    @Override
    protected boolean isDependingFeature(final EditingDomain domain, final EObject eObject,
            final EStructuralFeature feature, final Object value, final Collection<?> collection) {
        if (feature == STAMPPackage.Literals.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR) {
            return isDependingFeature(eObject, feature, value, 1);
        }
        return super.isDependingFeature(domain, eObject, feature, value, collection);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectDependents(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        super.collectDependents(domain, object, collection);
        collection.addAll(((HCFAnalysisResult) object).getHazardCausalFactors());
    }

}
