package net.astah.stpa.stamp.provider;

import java.io.IOException;
import java.net.URL;

import net.astah.emf.common.util.StandaloneInternalHelper;
import net.astah.emf.edit.provider.ItemProviders;

/**
 * Eclipse Workbench 外での Eclipse プラグインの構成をサポートします。
 */
public class STAMPEditPluginHelper extends STAMPEditPlugin.Implementation {

    /**
     * 指定された {@code URL} をリソースの起点とするインスタンスを構築します。
     * 
     * @param baseURL
     *            リソースの起点とする {@code URL}
     */
    public STAMPEditPluginHelper(final URL baseURL) {
        helper = new StandaloneInternalHelper(this, baseURL);
    }

    /**
     * Eclipse Workbench 外で Eclipse プラグインの構成処理を行います。
     */
    public static void init() {
        if (STAMPEditPlugin.getPlugin() == null) {
            new STAMPEditPluginHelper(STAMPEditPlugin.INSTANCE.getBaseURL());
        }
    }

    @Override
    public String getSymbolicName() {
        return "net.astah.stpa.stamp.edit";
    }

    @Override
    protected Object doGetImage(String key) throws IOException {
        return ItemProviders.getImage(getBaseURL(), "icons/", key, ".png");
    }
}
