/**
 */
package net.astah.stpa.stamp.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IItemStyledLabelProvider;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import net.astah.dd.di.edit.provider.IItemGraphicalStyleProvider;
import net.astah.emf.edit.provider.IItemChangeProcessorProvider;
import net.astah.emf.edit.provider.IItemComparatorProvider;
import net.astah.emf.edit.provider.IItemDiagramProvider;
import net.astah.emf.edit.provider.IItemMatchProvider;
import net.astah.emf.edit.provider.IItemDependencyProvider;
import net.astah.emf.edit.provider.IItemVariantLabelProvider;
import net.astah.stpa.stamp.util.STAMPAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPItemProviderAdapterFactory extends STAMPAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public STAMPItemProviderAdapterFactory() {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
        supportedTypes.add(IItemColorProvider.class);
        supportedTypes.add(IItemFontProvider.class);
        supportedTypes.add(IItemVariantLabelProvider.class);
        supportedTypes.add(IItemChangeProcessorProvider.class);
        supportedTypes.add(IItemComparatorProvider.class);
        supportedTypes.add(IItemDependencyProvider.class);
        supportedTypes.add(IItemDiagramProvider.class);
        supportedTypes.add(IItemMatchProvider.class);
        supportedTypes.add(IItemGraphicalStyleProvider.class);
        supportedTypes.add(IItemStyledLabelProvider.class);
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Component} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComponentItemProvider componentItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Component}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createComponentAdapter() {
        if (componentItemProvider == null) {
            componentItemProvider = new ComponentItemProvider(this);
        }

        return componentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Note} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NoteItemProvider noteItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Note}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNoteAdapter() {
        if (noteItemProvider == null) {
            noteItemProvider = new NoteItemProvider(this);
        }

        return noteItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ControlStructure} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlStructureItemProvider controlStructureItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ControlStructure}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlStructureAdapter() {
        if (controlStructureItemProvider == null) {
            controlStructureItemProvider = new ControlStructureItemProvider(this);
        }

        return controlStructureItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ControlAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlActionItemProvider controlActionItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ControlAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlActionAdapter() {
        if (controlActionItemProvider == null) {
            controlActionItemProvider = new ControlActionItemProvider(this);
        }

        return controlActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.UCAAnalysisResult} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCAAnalysisResultItemProvider ucaAnalysisResultItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.UCAAnalysisResult}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createUCAAnalysisResultAdapter() {
        if (ucaAnalysisResultItemProvider == null) {
            ucaAnalysisResultItemProvider = new UCAAnalysisResultItemProvider(this);
        }

        return ucaAnalysisResultItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.UnsafeControlAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UnsafeControlActionItemProvider unsafeControlActionItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.UnsafeControlAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createUnsafeControlActionAdapter() {
        if (unsafeControlActionItemProvider == null) {
            unsafeControlActionItemProvider = new UnsafeControlActionItemProvider(this);
        }

        return unsafeControlActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.STPAAnalysis} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected STPAAnalysisItemProvider stpaAnalysisItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.STPAAnalysis}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSTPAAnalysisAdapter() {
        if (stpaAnalysisItemProvider == null) {
            stpaAnalysisItemProvider = new STPAAnalysisItemProvider(this);
        }

        return stpaAnalysisItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ProcessModel} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ProcessModelItemProvider processModelItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ProcessModel}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createProcessModelAdapter() {
        if (processModelItemProvider == null) {
            processModelItemProvider = new ProcessModelItemProvider(this);
        }

        return processModelItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ProcessVariable} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ProcessVariableItemProvider processVariableItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ProcessVariable}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createProcessVariableAdapter() {
        if (processVariableItemProvider == null) {
            processVariableItemProvider = new ProcessVariableItemProvider(this);
        }

        return processVariableItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ProcessValue} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ProcessValueItemProvider processValueItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ProcessValue}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createProcessValueAdapter() {
        if (processValueItemProvider == null) {
            processValueItemProvider = new ProcessValueItemProvider(this);
        }

        return processValueItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ControlLink} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlLinkItemProvider controlLinkItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ControlLink}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlLinkAdapter() {
        if (controlLinkItemProvider == null) {
            controlLinkItemProvider = new ControlLinkItemProvider(this);
        }

        return controlLinkItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Accident} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AccidentItemProvider accidentItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Accident}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAccidentAdapter() {
        if (accidentItemProvider == null) {
            accidentItemProvider = new AccidentItemProvider(this);
        }

        return accidentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Hazard} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HazardItemProvider hazardItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Hazard}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHazardAdapter() {
        if (hazardItemProvider == null) {
            hazardItemProvider = new HazardItemProvider(this);
        }

        return hazardItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.SafetyConstraint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SafetyConstraintItemProvider safetyConstraintItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.SafetyConstraint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSafetyConstraintAdapter() {
        if (safetyConstraintItemProvider == null) {
            safetyConstraintItemProvider = new SafetyConstraintItemProvider(this);
        }

        return safetyConstraintItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Precondition} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PreconditionItemProvider preconditionItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Precondition}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPreconditionAdapter() {
        if (preconditionItemProvider == null) {
            preconditionItemProvider = new PreconditionItemProvider(this);
        }

        return preconditionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Countermeasure} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CountermeasureItemProvider countermeasureItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Countermeasure}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCountermeasureAdapter() {
        if (countermeasureItemProvider == null) {
            countermeasureItemProvider = new CountermeasureItemProvider(this);
        }

        return countermeasureItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.UCAGuideWordSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCAGuideWordSetItemProvider ucaGuideWordSetItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.UCAGuideWordSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createUCAGuideWordSetAdapter() {
        if (ucaGuideWordSetItemProvider == null) {
            ucaGuideWordSetItemProvider = new UCAGuideWordSetItemProvider(this);
        }

        return ucaGuideWordSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HCFHintWordSet} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HCFHintWordSetItemProvider hcfHintWordSetItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HCFHintWordSet}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHCFHintWordSetAdapter() {
        if (hcfHintWordSetItemProvider == null) {
            hcfHintWordSetItemProvider = new HCFHintWordSetItemProvider(this);
        }

        return hcfHintWordSetItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.UCAAnalysis} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCAAnalysisItemProvider ucaAnalysisItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.UCAAnalysis}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createUCAAnalysisAdapter() {
        if (ucaAnalysisItemProvider == null) {
            ucaAnalysisItemProvider = new UCAAnalysisItemProvider(this);
        }

        return ucaAnalysisItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.LinkEnd} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LinkEndItemProvider linkEndItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.LinkEnd}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLinkEndAdapter() {
        if (linkEndItemProvider == null) {
            linkEndItemProvider = new LinkEndItemProvider(this);
        }

        return linkEndItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.UCAGuideWord} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCAGuideWordItemProvider ucaGuideWordItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.UCAGuideWord}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createUCAGuideWordAdapter() {
        if (ucaGuideWordItemProvider == null) {
            ucaGuideWordItemProvider = new UCAGuideWordItemProvider(this);
        }

        return ucaGuideWordItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HCFAnalysis} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HCFAnalysisItemProvider hcfAnalysisItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HCFAnalysis}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHCFAnalysisAdapter() {
        if (hcfAnalysisItemProvider == null) {
            hcfAnalysisItemProvider = new HCFAnalysisItemProvider(this);
        }

        return hcfAnalysisItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HCFAnalysisResult} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HCFAnalysisResultItemProvider hcfAnalysisResultItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HCFAnalysisResult}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHCFAnalysisResultAdapter() {
        if (hcfAnalysisResultItemProvider == null) {
            hcfAnalysisResultItemProvider = new HCFAnalysisResultItemProvider(this);
        }

        return hcfAnalysisResultItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HazardCausalFactor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HazardCausalFactorItemProvider hazardCausalFactorItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HazardCausalFactor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHazardCausalFactorAdapter() {
        if (hazardCausalFactorItemProvider == null) {
            hazardCausalFactorItemProvider = new HazardCausalFactorItemProvider(this);
        }

        return hazardCausalFactorItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HazardScenario} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HazardScenarioItemProvider hazardScenarioItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HazardScenario}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHazardScenarioAdapter() {
        if (hazardScenarioItemProvider == null) {
            hazardScenarioItemProvider = new HazardScenarioItemProvider(this);
        }

        return hazardScenarioItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.HCFHintWord} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HCFHintWordItemProvider hcfHintWordItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.HCFHintWord}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createHCFHintWordAdapter() {
        if (hcfHintWordItemProvider == null) {
            hcfHintWordItemProvider = new HCFHintWordItemProvider(this);
        }

        return hcfHintWordItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.ControlLoop} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ControlLoopItemProvider controlLoopItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.ControlLoop}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createControlLoopAdapter() {
        if (controlLoopItemProvider == null) {
            controlLoopItemProvider = new ControlLoopItemProvider(this);
        }

        return controlLoopItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.Feedback} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FeedbackItemProvider feedbackItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.Feedback}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFeedbackAdapter() {
        if (feedbackItemProvider == null) {
            feedbackItemProvider = new FeedbackItemProvider(this);
        }

        return feedbackItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.FeedbackLink} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FeedbackLinkItemProvider feedbackLinkItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.FeedbackLink}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFeedbackLinkAdapter() {
        if (feedbackLinkItemProvider == null) {
            feedbackLinkItemProvider = new FeedbackLinkItemProvider(this);
        }

        return feedbackLinkItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link net.astah.stpa.stamp.NoteAnchor} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NoteAnchorItemProvider noteAnchorItemProvider;

    /**
     * This creates an adapter for a {@link net.astah.stpa.stamp.NoteAnchor}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNoteAnchorAdapter() {
        if (noteAnchorItemProvider == null) {
            noteAnchorItemProvider = new NoteAnchorItemProvider(this);
        }

        return noteAnchorItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type) {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type) {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type) {
        if (isFactoryForType(type)) {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void fireNotifyChanged(Notification notification) {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null) {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void dispose() {
        if (stpaAnalysisItemProvider != null) stpaAnalysisItemProvider.dispose();
        if (noteItemProvider != null) noteItemProvider.dispose();
        if (noteAnchorItemProvider != null) noteAnchorItemProvider.dispose();
        if (accidentItemProvider != null) accidentItemProvider.dispose();
        if (hazardItemProvider != null) hazardItemProvider.dispose();
        if (safetyConstraintItemProvider != null) safetyConstraintItemProvider.dispose();
        if (preconditionItemProvider != null) preconditionItemProvider.dispose();
        if (controlStructureItemProvider != null) controlStructureItemProvider.dispose();
        if (componentItemProvider != null) componentItemProvider.dispose();
        if (processModelItemProvider != null) processModelItemProvider.dispose();
        if (processVariableItemProvider != null) processVariableItemProvider.dispose();
        if (processValueItemProvider != null) processValueItemProvider.dispose();
        if (linkEndItemProvider != null) linkEndItemProvider.dispose();
        if (countermeasureItemProvider != null) countermeasureItemProvider.dispose();
        if (hazardCausalFactorItemProvider != null) hazardCausalFactorItemProvider.dispose();
        if (hazardScenarioItemProvider != null) hazardScenarioItemProvider.dispose();
        if (unsafeControlActionItemProvider != null) unsafeControlActionItemProvider.dispose();
        if (controlActionItemProvider != null) controlActionItemProvider.dispose();
        if (controlLinkItemProvider != null) controlLinkItemProvider.dispose();
        if (ucaGuideWordSetItemProvider != null) ucaGuideWordSetItemProvider.dispose();
        if (ucaGuideWordItemProvider != null) ucaGuideWordItemProvider.dispose();
        if (hcfHintWordSetItemProvider != null) hcfHintWordSetItemProvider.dispose();
        if (hcfHintWordItemProvider != null) hcfHintWordItemProvider.dispose();
        if (ucaAnalysisItemProvider != null) ucaAnalysisItemProvider.dispose();
        if (ucaAnalysisResultItemProvider != null) ucaAnalysisResultItemProvider.dispose();
        if (hcfAnalysisItemProvider != null) hcfAnalysisItemProvider.dispose();
        if (hcfAnalysisResultItemProvider != null) hcfAnalysisResultItemProvider.dispose();
        if (controlLoopItemProvider != null) controlLoopItemProvider.dispose();
        if (feedbackLinkItemProvider != null) feedbackLinkItemProvider.dispose();
        if (feedbackItemProvider != null) feedbackItemProvider.dispose();
    }

}
