package net.astah.stpa.stamp.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.emf.edit.command.InitializeFeatureCommand;
import net.astah.stpa.stamp.ControlStructure;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STPAAnalysis;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.STPAAnalysis} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STPAAnalysisItemProvider extends NamedElementItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysisItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addOwnerPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Owner feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addOwnerPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STPAAnalysis_owner_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STPAAnalysis_owner_feature", "_UI_STPAAnalysis_type"),
                 STAMPPackage.Literals.STPA_ANALYSIS__OWNER,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__ACCIDENT);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__HAZARD);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__SAFETY_CONSTRAINT);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__PRECONDITION);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__CONTROL_STRUCTURE);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__COUNTERMEASURE);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__UCA_GUIDE_WORD_SET);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__HCF_HINT_WORD_SET);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__UCA_ANALYSIS);
            childrenFeatures.add(STAMPPackage.Literals.STPA_ANALYSIS__HCF_ANALYSIS);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns STPAAnalysis.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STPAAnalysis"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((STPAAnalysis)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_STPAAnalysis_type") :
            getString("_UI_STPAAnalysis_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STPAAnalysis.class)) {
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__ACCIDENT,
                 STAMPFactory.eINSTANCE.createAccident()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__HAZARD,
                 STAMPFactory.eINSTANCE.createHazard()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__SAFETY_CONSTRAINT,
                 STAMPFactory.eINSTANCE.createSafetyConstraint()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__PRECONDITION,
                 STAMPFactory.eINSTANCE.createPrecondition()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__CONTROL_STRUCTURE,
                 STAMPFactory.eINSTANCE.createControlStructure()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__COUNTERMEASURE,
                 STAMPFactory.eINSTANCE.createCountermeasure()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR,
                 STAMPFactory.eINSTANCE.createHazardCausalFactor()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION,
                 STAMPFactory.eINSTANCE.createUnsafeControlAction()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__UCA_GUIDE_WORD_SET,
                 STAMPFactory.eINSTANCE.createUCAGuideWordSet()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__HCF_HINT_WORD_SET,
                 STAMPFactory.eINSTANCE.createHCFHintWordSet()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__UCA_ANALYSIS,
                 STAMPFactory.eINSTANCE.createUCAAnalysis()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPPackage.Literals.STPA_ANALYSIS__HCF_ANALYSIS,
                 STAMPFactory.eINSTANCE.createHCFAnalysis()));
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createCreateChildCommand(EditingDomain domain, EObject owner,
            EStructuralFeature feature, Object value, int index, Collection<?> collection) {
        Command command = super.createCreateChildCommand(domain, owner, feature, value, index,
                collection);
        switch (feature.getFeatureID()) {
        case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
        case STAMPPackage.STPA_ANALYSIS__HAZARD:
        case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
        case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
        case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
        case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
            command = command.chain(InitializeFeatureCommand.create(domain, value,
                    STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID));
            command = command.chain(InitializeFeatureCommand.create(domain, value,
                    STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION));
            break;
        }
        return command;
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command factorAddCommand(EditingDomain domain, CommandParameter commandParameter) {
        Command command = super.factorAddCommand(domain, commandParameter);
        if (command == UnexecutableCommand.INSTANCE) {
            // オブジェクトの追加を配下のコントロールストラクチャーに対して試行する
            Collection<?> collection = commandParameter.getCollection();
            for (ControlStructure owner : ((STPAAnalysis) commandParameter.getOwner())
                    .getControlStructures()) {
                Command result = AddCommand.create(domain, owner, null, collection);
                if (result.canExecute()) {
                    return result;
                }
                result.dispose();
            }
        }
        return command;
    }
}
