package net.astah.stpa.stamp.command;

import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CopyCommand;
import org.eclipse.emf.edit.domain.EditingDomain;

import net.astah.emf.edit.command.DiagramCopyCommand;

/**
 * STAMP/STPA モデル用のモデル複製コマンドです。
 */
public class STAMPModelCopyCommand extends DiagramCopyCommand {

    public STAMPModelCopyCommand(final EditingDomain domain, final Object context,
            final EObject owner, final CopyCommand.Helper copyHelper) {
        this(domain, context, owner, copyHelper, true);
    }

    public STAMPModelCopyCommand(final EditingDomain domain, final Object context,
            final EObject owner, final CopyCommand.Helper copyHelper, final boolean optimize) {
        super(domain, context, owner, copyHelper, optimize);
    }

    @Override
    protected void addCreateCopyCommands(final CompoundCommand compoundCommand,
            final EObject object) {
        super.addCreateCopyCommands(compoundCommand, object);
        if (object == owner) {
            addExtraCreateCopyCommands(compoundCommand, object);
        }
    }

    @Override
    protected Iterable<EObject> getExtraContents(final EObject object, final int depth) {
        return new STAMPExtraContentSwitch(depth).doSwitch(object);
    }

}
