/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

import net.astah.emf.common.notify.EFeaturePath;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.notation.HCFTable;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.HCFTable} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HCFTableItemProvider extends STAMPTableItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFTableItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addUnsafeControlActionPropertyDescriptor(object);
            addControlLoopPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Unsafe Control Action feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addUnsafeControlActionPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFTable_unsafeControlAction_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFTable_unsafeControlAction_feature", "_UI_HCFTable_type"),
                 STAMPNotationPackage.Literals.HCF_TABLE__UNSAFE_CONTROL_ACTION,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Control Loop feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addControlLoopPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_HCFTable_controlLoop_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_HCFTable_controlLoop_feature", "_UI_HCFTable_type"),
                 STAMPNotationPackage.Literals.HCF_TABLE__CONTROL_LOOP,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns HCFTable.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/HCFTable"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((HCFTable)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_HCFTable_type") :
            getString("_UI_HCFTable_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectDependents(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        super.collectDependents(domain, object, collection);
        final HCFTable table = (HCFTable) object;
        collection.addAll(EFeaturePath.builder()
                .add(STAMPNotationPackage.Literals.HCF_TABLE__UNSAFE_CONTROL_ACTION)
                .addInverse(STAMPPackage.Literals.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION)
                .create().getReferences(table));
    }

    /**
     * @generated NOT
     */
    @Override
    public void collectSharedComposites(final EditingDomain domain, final Object object,
            final Collection<Object> collection) {
        final HCFTable table = (HCFTable) object;
        addIfNotNull(collection, table.getControlLoop());
    }

}
