/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;

import com.google.common.collect.Iterables;

import net.astah.dd.di.util.DiagramElements;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.notation.STAMPComponentShape;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPControlStructureDiagram} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPControlStructureDiagramItemProvider extends STAMPDiagramItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPControlStructureDiagramItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addComponentExtractingTablePropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Component Extracting Table feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addComponentExtractingTablePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPControlStructureDiagram_componentExtractingTable_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPControlStructureDiagram_componentExtractingTable_feature", "_UI_STAMPControlStructureDiagram_type"),
                 STAMPNotationPackage.Literals.STAMP_CONTROL_STRUCTURE_DIAGRAM__COMPONENT_EXTRACTING_TABLE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This returns STAMPControlStructureDiagram.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPControlStructureDiagram"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((STAMPControlStructureDiagram)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_STAMPControlStructureDiagram_type") :
            getString("_UI_STAMPControlStructureDiagram_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * @generated NOT
     */
    @Override
    protected Command createDeleteDiagramElementCommand(Object object, EditingDomain domain,
            CommandParameter commandParameter) {
        final CompoundCommand command = new CompoundCommand();
        for (final STAMPComponentShape shape : Iterables.filter(commandParameter.getCollection(),
                STAMPComponentShape.class)) {
            final EObject model = DiagramElements.getModelElement(shape);
            // コンポーネントの図要素がすべて削除された場合に分析対象フラグをfalseにする
            if (isUnsetAnalysisTarget(model, shape)) {
                command.append(SetCommand.create(domain, model,
                        STAMPPackage.Literals.COMPONENT__IS_ANALYSIS_TARGET, false));
            }
        }
        command.append(super.createDeleteDiagramElementCommand(object, domain, commandParameter));
        return command;
    }

    private boolean isUnsetAnalysisTarget(final EObject model, final STAMPComponentShape shape) {
        final EFeaturePath path = EFeaturePath
                .build(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT);
        for (final STAMPComponentShape componentShape : Iterables.filter(path.getInverseReferences(model),
                STAMPComponentShape.class)) {
            if (shape != componentShape) {
                return false;
            }
        }
        return true;
    }
}
