/**
 */
package net.astah.stpa.stamp.notation.provider;


import java.awt.geom.Point2D;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.CopyCommand.Helper;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.dd.dc.Bounds;
import net.astah.dd.dc.DCFactory;
import net.astah.dd.dc.Dimension;
import net.astah.dd.dc.Point;
import net.astah.dd.di.DIPackage;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.edit.command.SetEdgeEndCommand;
import net.astah.dd.di.edit.provider.Geometries;
import net.astah.dd.di.edit.provider.IItemGeometryProvider;
import net.astah.dd.di.edit.provider.LayoutCalculator;
import net.astah.dd.di.util.DiagramElements;
import net.astah.emf.common.ecore.DataTypeEObject;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.emf.edit.provider.ExtraLabelVariant;
import net.astah.emf.edit.provider.LabelProviders;
import net.astah.golf.geom2D.Line2d;
import net.astah.golf.geom2D.Pnt2d;
import net.astah.notation.Edge;
import net.astah.notation.NotationPackage;
import net.astah.notation.edit.layout.AlignKind;
import net.astah.notation.edit.layout.FlowLayout;
import net.astah.notation.edit.layout.TextAreaLayout;
import net.astah.notation.provider.EdgeItemProvider;
import net.astah.notation.provider.GeometryProviderHelper;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.Link;
import net.astah.stpa.stamp.NoteAnchor;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.notation.STAMPCompartmentableShape;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationFactory;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.edit.command.InitializeSTAMPDiagramElementCommand;
import net.astah.stpa.stamp.notation.edit.command.STAMPDiagramElementCopyCommand;
import net.astah.stpa.stamp.notation.edit.layout.LayoutUtil;
import net.astah.stpa.stamp.util.STAMPSwitch;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPEdge} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPEdgeItemProvider extends EdgeItemProvider {
    public static final FlowLayout LAYOUT = new FlowLayout.Builder()
            .add(new TextAreaLayout.Builder(LayoutUtil.TEXT_AREA)
                    .minWidth(10)
                    .textGroupAlign(AlignKind.CENTER)
                    .lineWrappable(true)
                    .path(EFeaturePath.build(STAMPNotationPackage.Literals.STAMP_LABEL__TEXT)))
            .build();

    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPEdgeItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addSTAMPModelElementPropertyDescriptor(object);
            addSTAMPTargetEdgePropertyDescriptor(object);
            addSTAMPSourceEdgePropertyDescriptor(object);
            addSTAMPSourcePropertyDescriptor(object);
            addSTAMPTargetPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the STAMP Model Element feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPModelElementPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPModelElement_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPModelElement_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Target Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPTargetEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPTargetEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPTargetEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Source Edge feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPSourceEdgePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPDiagramElement_STAMPSourceEdge_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPDiagramElement_STAMPSourceEdge_feature", "_UI_STAMPDiagramElement_type"),
                 STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Source feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPSourcePropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPEdge_STAMPSource_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPEdge_STAMPSource_feature", "_UI_STAMPEdge_type"),
                 STAMPNotationPackage.Literals.STAMP_EDGE__STAMP_SOURCE,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the STAMP Target feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addSTAMPTargetPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPEdge_STAMPTarget_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPEdge_STAMPTarget_feature", "_UI_STAMPEdge_type"),
                 STAMPNotationPackage.Literals.STAMP_EDGE__STAMP_TARGET,
                 true,
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns STAMPEdge.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPEdge"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        return getString("_UI_STAMPEdge_type");
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPEdge.class)) {
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPEdge()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPLabel()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartment()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPCompartmentableShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPComponentShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPGraphicalShape()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlStructureDiagram()));

        newChildDescriptors.add
            (createChildParameter
                (STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT,
                 STAMPNotationFactory.eINSTANCE.createSTAMPControlLoopDiagram()));
    }

    /**
     * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
        Object childFeature = feature;
        Object childObject = child;

        boolean qualify =
            childFeature == NotationPackage.Literals.EDGE__SOURCE_ANCHOR ||
            childFeature == NotationPackage.Literals.EDGE__TARGET_ANCHOR;

        if (qualify) {
            return getString
                ("_UI_CreateChild_text2",
                 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
        }
        return super.getCreateChildText(owner, feature, child, selection);
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPNotationEditPlugin.INSTANCE;
    }

    @Override
    protected Command createSetEdgeEndCommand(Object object, EditingDomain domain,
            CommandParameter commandParameter) {
        return super.createSetEdgeEndCommand(object, domain, commandParameter);
    }

    @Override
    protected Command createSetEdgeEndCommand(EditingDomain domain, Object context, EObject owner,
            Object feature, Object value) {
        Command command = super.createSetEdgeEndCommand(domain, context, owner, feature, value);
        if (value instanceof STAMPDiagramElement) {
            final STAMPEdge edge = (STAMPEdge) owner;
            final STAMPDiagramElement edgeEnd = (STAMPDiagramElement) value;
            final Element edgeModel = DiagramElements.getModelElement(edge, Element.class);
            final Element edgeEndModel = DiagramElements.getModelElement(edgeEnd, Element.class);
            if (edgeModel == null || edgeEndModel == null) {
                return UnexecutableCommand.INSTANCE;
            }

            final Command extraCommand = new STAMPSwitch<Command>() {
                @Override
                public Command caseLink(final Link object) {
                    if (feature == SetEdgeEndCommand.SOURCE) {
                        return SetCommand.create(domain, object, STAMPPackage.Literals.LINK__SOURCE,
                                edgeEndModel);
                    } else if (feature == SetEdgeEndCommand.TARGET) {
                        return SetCommand.create(domain, object, STAMPPackage.Literals.LINK__TARGET,
                                edgeEndModel);
                    }
                    return null;
                }

                @Override
                public Command caseNoteAnchor(final NoteAnchor object) {
                    if (feature == SetEdgeEndCommand.SOURCE) {
                        if (object.getAnnotatedElement() == edgeEndModel) {
                            // reject self anchor.
                            return UnexecutableCommand.INSTANCE;
                        }
                        return SetCommand.create(domain, object,
                                STAMPPackage.Literals.NOTE_ANCHOR__OWNER, edgeEndModel);
                    } else if (feature == SetEdgeEndCommand.TARGET) {
                        if (object.getOwner() == edgeEndModel) {
                            // reject self anchor.
                            return UnexecutableCommand.INSTANCE;
                        }
                        return SetCommand.create(domain, object,
                                STAMPPackage.Literals.NOTE_ANCHOR__ANNOTATED_ELEMENT, edgeEndModel);
                    }
                    return null;
                }
            }.doSwitch(edgeModel);

            if (extraCommand != null) {
                command = command.chain(extraCommand);
            }
        }
        return command;
    }

    /**
     * @generated NOT
     */
    @Override
    public Point getElementOrigin(final Object object, final Object child,
            final LayoutCalculator layoutCalculator) {
        if (child != null && !(child instanceof STAMPLabel)) {
            return super.getElementOrigin(object, child, layoutCalculator);
        }
        return getLabelOrigin((Edge) object, layoutCalculator);
    }

    private Point getLabelOrigin(final Edge edge, final LayoutCalculator layoutCalculator) {
        final Pnt2d midpoint = Geometries.toPnt2d(GeometryProviderHelper.getEdgeMidpoint(
                (STAMPEdge) edge, null, layoutCalculator));
        final List<Pnt2d> waypoints = Geometries
                .toPnt2d(layoutCalculator.getWaypoints((STAMPEdge) edge, null));

        // エッジの中点がある線の角度を求める
        Pnt2d nextPoint = waypoints.get(0);
        double minDist = Double.POSITIVE_INFINITY;
        for (int i = 0; i < waypoints.size() - 1; i++) {
            final Line2d line = new Line2d(waypoints.get(i), waypoints.get(i + 1));
            final double dist = line.ptLineDist(midpoint);
            if (dist < minDist) {
                minDist = dist;
                nextPoint = waypoints.get(i + 1);
            }
        }
        double theta = Math.atan2(nextPoint.getY() - midpoint.getY(),
                nextPoint.getX() - midpoint.getX());
        // 線から時計まわり90°の方向にずらす
        theta += Math.toRadians(90);

        // 横軸半径70, 縦軸半径30の楕円の角度thetaの半径rをずらし幅とした
        final double horizontal = 70;
        final double vertical = 30;
        final double r = Math.abs(Math.sqrt((Math.pow(horizontal, 2) * Math.pow(vertical, 2))
                / (Math.pow(horizontal, 2) * Math.pow(Math.sin(theta), 2)
                        + Math.pow(vertical, 2) * Math.pow(Math.cos(theta), 2))));
        final double x = r * Math.cos(theta);
        final double y = r * Math.sin(theta);
        // 楕円の中心をラベルの左上の点に合わせ、ずらす
        final Pnt2d basePoint = new Pnt2d(midpoint.getX() - 53.5, midpoint.getY() - 10.0625);

        return Geometries.toPoint(new Point2D.Double(basePoint.getX() + x, basePoint.getY() + y));
    }

    @Override
    protected Command createCopyCommand(EditingDomain domain, Object context, EObject owner,
            Helper helper) {
        return new STAMPDiagramElementCopyCommand(domain, context, owner, helper,
                domain.getOptimizeCopy());
    }

    @Override
    public void collectDependents(EditingDomain domain, Object object,
            Collection<Object> collection) {
        final STAMPEdge edge = (STAMPEdge) object;
        collection.addAll(edge.getOwnedElements());
        for (final Element element : edge.getSTAMPModelElements()) {
            if (element instanceof NoteAnchor) {
                collection.add(element);
            }
        }
        super.collectDependents(domain, object, collection);
    }

    @Override
    public String getModelTreeText(final Object object) {
        final STAMPEdge edge = (STAMPEdge) object;
        return DiagramElements.mapModelElement(edge, modelElement -> {
            return LabelProviders.getText(modelElement, ExtraLabelVariant.MODEL_TREE);
        }, "");
    }

    @Override
    protected Command createCreateChildCommand(EditingDomain domain, EObject owner,
            EStructuralFeature feature, Object value, int index, Collection<?> collection) {
        Command command =
                super.createCreateChildCommand(domain, owner, feature, value, index, collection);
        if (feature == DIPackage.Literals.DIAGRAM_ELEMENT__OWNED_ELEMENT) {
            command = new InitializeSTAMPDiagramElementCommand(domain, owner, value, index).chain(command);
        }
        return command;
    }

    /**
     * @see IItemGeometryProvider#getElementLocationOn(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getElementLocationOn(final Object object, final Object child,
            final LayoutCalculator layoutCalculator) {
        final STAMPEdge edge = (STAMPEdge) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(edge);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(children);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        LAYOUT.calculateTotalBounds(edge, null, childrenMap, layoutCalculator, totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = LAYOUT
                .calculate(childrenMap, totalBounds, layoutCalculator, Point.class);
        return (Point) result.get(child);
    }

    /**
     * @see IItemGeometryProvider#getElementSize(Object, Object, LayoutCalculator)
     * @generated NOT
     */
    public Dimension getElementSize(final Object object, final Object child,
            final LayoutCalculator layoutCalculator) {
        final STAMPEdge edge = (STAMPEdge) object;
        final List<DiagramElement> children = layoutCalculator.getOwnedElements(edge);
        final Map<String, List<DiagramElement>> childrenMap = LayoutUtil
                .createChildrenMap(children);
        final Bounds totalBounds = DCFactory.eINSTANCE.createBounds();
        LAYOUT.calculateTotalBounds(edge, null, childrenMap, layoutCalculator, totalBounds);
        final Map<DiagramElement, DataTypeEObject> result = LAYOUT
                .calculate(childrenMap, totalBounds, layoutCalculator, Dimension.class);
        return (Dimension) result.get(child);
    }

    @Override
    protected boolean isDependingFeature(final EditingDomain domain, final EObject eObject,
            final EStructuralFeature feature, final Object value, final Collection<?> collection) {
        if (feature == STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT) {
            return isDependingFeature(eObject, feature, value, 1);
        }
        return super.isDependingFeature(domain, eObject, feature, value, collection);
    }

    @Override
    protected Command createAddCommand(EditingDomain domain, EObject owner,
            EStructuralFeature feature, Collection<?> collection, int index) {

        // Edgeの中にコンポーネントなどは入れられない
        if(feature == DIPackage.Literals.DIAGRAM_ELEMENT__OWNED_ELEMENT && 
                collection.stream().anyMatch(m -> m instanceof STAMPCompartmentableShape)) {
            return UnexecutableCommand.INSTANCE;
        }

        return super.createAddCommand(domain, owner, feature, collection, index);
    }

    @Override
    public List<Point> getControlPoints(final Object object,
            final LayoutCalculator layoutCalculator) {
        return STAMPGeometryProviderHelper.getControlPoints((Edge) object, null, layoutCalculator);
    }

}
