/**
 */
package net.astah.stpa.stamp.notation.provider;

import static java.util.Collections.emptySet;
import static net.astah.stpa.stamp.notation.STAMPNotationPackage.Literals.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Objects;
import java.util.Set;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.common.command.IdentityCommand;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.SetCommand;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import net.astah.dd.dc.Bounds;
import net.astah.dd.dc.DCFactory;
import net.astah.dd.dc.Dimension;
import net.astah.dd.dc.Point;
import net.astah.dd.di.Diagram;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.edit.provider.IItemGeometryProvider;
import net.astah.dd.di.edit.provider.LayoutCalculator;
import net.astah.dd.di.util.DiagramElements;
import net.astah.emf.common.notify.EFeaturePath;
import net.astah.notation.NotationPackage;
import net.astah.notation.Shape;
import net.astah.notation.edit.layout.DiagramElementOperations;
import net.astah.notation.provider.GeometryProviderHelper;
import net.astah.notation.provider.MoveLocationHelper;
import net.astah.notation.provider.ShapeItemProvider;
import net.astah.stpa.stamp.Component;
import net.astah.stpa.stamp.ControlAction;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.NamedElement;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.ProcessValue;
import net.astah.stpa.stamp.ProcessVariable;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.Signal;
import net.astah.stpa.stamp.UCAAnalysisResult;
import net.astah.stpa.stamp.notation.STAMPComponentShape;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.UCATable;
import net.astah.stpa.stamp.notation.util.STAMPDiagramElements;
import net.astah.stpa.stamp.util.STAMPSwitch;

/**
 * This is the item provider adapter for a {@link net.astah.stpa.stamp.notation.STAMPLabel} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class STAMPLabelItemProvider extends STAMPShapeItemProvider {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPLabelItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

            addTextPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Text feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTextPropertyDescriptor(Object object) {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_STAMPLabel_text_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_STAMPLabel_text_feature", "_UI_STAMPLabel_type"),
                 STAMPNotationPackage.Literals.STAMP_LABEL__TEXT,
                 true,
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This returns STAMPLabel.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/STAMPLabel"));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean shouldComposeCreationImage() {
        return true;
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((STAMPLabel)object).getText();
        return label == null || label.length() == 0 ?
            getString("_UI_STAMPLabel_type") :
            getString("_UI_STAMPLabel_type") + " " + label;
    }
    

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(STAMPLabel.class)) {
            case STAMPNotationPackage.STAMP_LABEL__TEXT:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);
    }

    /**
     * 変更対象の文字列を書式化して返す.
     * @generated NOT
     */
    @Override
    public String getModifyingText(Object object) {
        STAMPLabel label = (STAMPLabel) object;
        for (Element element : label.getSTAMPModelElements()) {
            return new STAMPSwitch<String>() {
                @Override
                public String caseComponent(Component component) {
                    return label.getText();
                }

                @Override
                public String caseNote(final Note object) {
                    return label.getText();
                }
            }.doSwitch(element);
        }
        return label.getText();
    }

    /**
     * 文字列を解析して変更コマンドを構築して返す.
     * @generated NOT
     */
    @Override
    public Command parseModifyingText(EditingDomain domain, Object owner, String text) {
        STAMPLabel label = (STAMPLabel) owner;
        for (Element element : label.getSTAMPModelElements()) {
            return new STAMPSwitch<Command>() {
                @Override
                public Command caseNamedElement(NamedElement object) {
                    return SetCommand.create(domain, object,
                            STAMPPackage.Literals.NAMED_ELEMENT__NAME, replaceLineFeedCode(text));
                }

                @Override
                public Command caseNote(final Note object) {
                    return SetCommand.create(domain, object, STAMPPackage.Literals.NOTE__BODY,
                            text);
                }
            }.doSwitch(element);
        }
        return SetCommand.create(domain, owner, STAMPNotationPackage.Literals.STAMP_LABEL__TEXT,
                text);
    }

    /**
     * @see IItemGeometryProvider#getLocationOn(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Point getLocationOn(final Object object, final LayoutCalculator layoutCalculator) {
        final Shape label = (Shape) object;
        return GeometryProviderHelper.getLocationOn(label, null, layoutCalculator);
    }

    /**
     * @see IItemGeometryProvider#getBoundsSize(Object, LayoutCalculator)
     * @generated NOT
     */
    @Override
    public Dimension getBoundsSize(Object object, LayoutCalculator layoutCalculator) {
        final Object parent = getOriginatingElement(object, layoutCalculator);
        return layoutCalculator.getElementSize(parent, object);
    }

    protected boolean adjustCopySelection(EditingDomain domain, Object owner,
            Set<Object> selection) {
        STAMPLabel label = (STAMPLabel) owner;
        boolean changed = selection.remove(label);
        return super.adjustCopySelection(domain, owner, selection) || changed;
    }

    protected boolean adjustMoveSelection(final EditingDomain domain, final Object owner,
            final Set<Object> selection) {
        if (owner instanceof STAMPLabel) {
            DiagramElement owningElement = ((STAMPLabel) owner).getOwningElement();
            if (owningElement instanceof STAMPShape) {
                selection.remove(owner);
                selection.add(owningElement);
                return true;
            }
        }
        return false;
    }

    @Override
    public void collectDependents(EditingDomain domain, Object object,
            Collection<Object> collection) {
        STAMPLabel label = (STAMPLabel) object;
        DiagramElement owner = label.getOwningElement();
        if (Objects.equals(owner.getModelElements(), label.getModelElements())) {
            collection.add(owner);
        }
        
        ControlAction controlAction = getControlAction(label);
        if (controlAction != null) {
            List<UCAAnalysisResult> referedUCAAnalysisResults = getReferedUCAAnalysisResults(label);
            referedUCAAnalysisResults.removeAll(getNotDeleteResults(collection, controlAction, label));
            collection.addAll(referedUCAAnalysisResults);
        }
        super.collectDependents(domain, object, collection);
    }

    private String replaceLineFeedCode(final String originString) {
        final String replaceString1 = originString.replaceAll("\r\n", " ");
        final String replaceString2 = replaceString1.replaceAll("\r", " ");
        final String result = replaceString2.replaceAll("\n", " ");
        return result;
    }

    private List<UCAAnalysisResult> getReferedUCAAnalysisResults(STAMPLabel label) {
        List<UCAAnalysisResult> referedUCAAnalysisResults = new ArrayList<UCAAnalysisResult>();
        List<UCATable> referedUCATables = getReferedUCATables(label);
        for (UCATable ucaTable : referedUCATables) {
            for (UCAAnalysisResult result : ucaTable.getResults()) {
                if (result.getControlAction() == getControlAction(label)) {
                    referedUCAAnalysisResults.add(result);
                }
            }
        }
        return referedUCAAnalysisResults;
    }

    private List<UCAAnalysisResult> getNotDeleteResults(Collection<Object> deletes, ControlAction controlAction, STAMPLabel current) {
        List<STAMPLabel> labels = STAMPDiagramElements.getDiagramElements(controlAction, null,
                STAMPLabel.class);
        labels.remove(current);
        List<UCAAnalysisResult> notDeleteUCAAnalysisResults = new ArrayList<UCAAnalysisResult>();
        for (STAMPLabel stampLabel : labels) {
            if (!deletes.contains(stampLabel)) {
                notDeleteUCAAnalysisResults.addAll(getReferedUCAAnalysisResults(stampLabel));
            }
        }
        return notDeleteUCAAnalysisResults;
    }

    private ControlAction getControlAction(STAMPLabel label) {
        for (final Element element : label.getSTAMPModelElements()) {
            if (element instanceof ControlAction) {
                return (ControlAction)element;
             }
         }
        return null;
    }

    private List<UCATable> getReferedUCATables(final STAMPLabel label) {
        List<UCATable> ucaTables = new ArrayList<UCATable>();
        Diagram diagram = DiagramElementOperations.getDiagram(label);
        if (diagram instanceof STAMPControlStructureDiagram) {
            final EFeaturePath path = EFeaturePath.build(UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM);
            for (EObject eObject : path.getInverseReferences(diagram)) {
                if (eObject instanceof UCATable) {
                    ucaTables.add((UCATable)eObject);
                }
            }
        }
        return ucaTables;
    }
    
    @Override
    public Collection<?> getIntentionDomains(Object object) {
        if (DiagramElements.isModelElementPresent((STAMPLabel) object, ControlAction.class)) {
            // ラベルの削除は警告する必要がない
            return emptySet();
        }
        return super.getIntentionDomains(object);
    }
    
    @Override
    protected Command createSetBoundsCommand(EditingDomain domain, Object context, EObject owner,
            Object feature, Object value) {
        STAMPLabel label = (STAMPLabel) owner;
        if (!(label.getOwningElement() instanceof STAMPEdge)) {
            return UnexecutableCommand.INSTANCE;
        }
        return super.createSetBoundsCommand(domain, context, owner, feature, value);
    }
    
    /**
     * @see ShapeItemProvider#createLocationMoveLocationCommand(EditingDomain,Object,EObject,Object)
     * @generated NOT
     */
    @Override
    protected Command createLocationMoveLocationCommand(EditingDomain domain,
            Object context,
            EObject owner,
            Object value) {
        if (((DiagramElement) owner).getOwningElement() instanceof STAMPComponentShape) {
            return IdentityCommand.INSTANCE;
        }
        return MoveLocationHelper.INSTANCE.applyFeature(domain, context, owner,
                NotationPackage.Literals.SHAPE__LOCATION, value);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    protected Command createDefaultSetBoundsCommand(EditingDomain domain, Object context,
            EObject owner, Object value) {
        final STAMPLabel label = (STAMPLabel) owner;
        if (value instanceof Bounds && label.getOwningElement() instanceof STAMPEdge) {
            final Bounds bounds = (Bounds) value;
            final CompoundCommand command = new CompoundCommand();

            // Boundsから設定すべきPointを算出
            final Point locationPoint = DCFactory.eINSTANCE.createPoint(bounds.getX(), bounds.getY());
            command.append(createSetLocationCommand(domain, context, owner, null, locationPoint));

            command.append(createSetSizeCommand(domain, context, owner, null,
                    DCFactory.eINSTANCE.createDimension(bounds.getWidth(), bounds.getHeight())));

            return command;
        }
        return UnexecutableCommand.INSTANCE;
    }

    /**
     * @generated NOT
     */
    @Override
    protected boolean adjustDepthSelection(EditingDomain domain,
            Object owner,
            Set<Object> selection) {
        STAMPLabel label = (STAMPLabel) owner;

        boolean changed = false;
        if (selection.contains(label)) {
            changed |= selection.remove(label);
        }
        DiagramElement owningElement = label.getOwningElement();
        if (!selection.contains(owningElement)) {
            if (owningElement instanceof Shape) {
                changed |= selection.add(owningElement);
            }
        }

        return super.adjustDepthSelection(domain, owner, selection) || changed;
    }

    @Override
    protected boolean adjustDeleteDiagramElementSelection(EditingDomain domain, Object owner,
            Set<Object> selection) {
        final STAMPLabel label = (STAMPLabel) owner;
        boolean changed = super.adjustDeleteDiagramElementSelection(domain, owner, selection);

        DiagramElement owningElement = label.getOwningElement();
        if (owningElement instanceof STAMPComponentShape && selection.contains(label)) {
            changed |= selection.add(owningElement);
            return changed;
        }
        
        for (final EObject modelElement : label.getModelElements()) {
            if (modelElement instanceof Signal || modelElement instanceof ProcessVariable
                    || modelElement instanceof ProcessValue) {
                if (selection.contains(label)) {
                    changed |= selection.add(modelElement);
                } else {
                    changed |= selection.remove(modelElement);
                }
                break;
            }
        }

        return changed;
    }

}
