package net.astah.stpa.stamp.notation.provider;

import static java.util.Arrays.asList;

import java.util.Map;
import java.util.Set;

import org.eclipse.emf.ecore.EClass;

import net.astah.emf.edit.provider.decorator.BasicContentDecoratorFactoryImpl;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * STAMP の構造ツリーに追加するノードを決めるクラスです。
 */
public class STAMPNotationStructureTreeDecoratorFactory extends BasicContentDecoratorFactoryImpl {

    @Override
    protected Map<EClass, Set<EClass>> prepareExcludeKindOf() {
        final Map<EClass, Set<EClass>> excludeKindOf = super.prepareExcludeKindOf();

        // STAMP図から図要素を除外
        addValues(excludeKindOf, STAMPNotationPackage.Literals.STAMP_DIAGRAM,
                asList(STAMPNotationPackage.Literals.STAMP_DIAGRAM_ELEMENT));

        return excludeKindOf;
    }

}
