package net.astah.stpa.stamp.notation.editor;

import static java.util.Collections.emptyList;

import java.util.List;

import net.astah.notation.editor.ShapeViewElementImpl;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPShape;

/**
 * {@code STAMPShape} を表示するためのビューエレメントを実装するクラスです。
 */
public class STAMPShapeViewElementImpl<E extends STAMPShape>
        extends ShapeViewElementImpl<E, STAMPDiagramElement> {

    public STAMPShapeViewElementImpl(E model) {
        super(model);
    }

    @Override
    protected List<? extends STAMPDiagramElement> getOwnedElements() {
        final STAMPShape model = getModel();
        if (model != null) {
            return model.getSTAMPOwnedElements();
        }
        return emptyList();
    }

}
