/**
 */
package net.astah.stpa.stamp.notation.impl;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import net.astah.dd.dc.Bounds;

import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.Edge;
import net.astah.dd.di.Style;
import net.astah.emf.common.collect.EObjectELists;
import net.astah.emf.common.ecore.EFeatureCache;
import net.astah.stpa.stamp.ControlAction;
import net.astah.stpa.stamp.LinkEnd;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.UCAAnalysis;

import net.astah.stpa.stamp.UCAAnalysisResult;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.UCATable;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

import com.google.common.collect.Iterators;
import com.google.common.collect.Lists;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>UCA Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.UCATableImpl#getControlStructureDiagram <em>Control Structure Diagram</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.UCATableImpl#getAnalysis <em>Analysis</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.UCATableImpl#getControlActions <em>Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.UCATableImpl#getResults <em>Result</em>}</li>
 * </ul>
 *
 * @generated
 */
public class UCATableImpl extends STAMPTableImpl implements UCATable {
    /**
     * The cached value of the '{@link #getControlStructureDiagram() <em>Control Structure Diagram</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getControlStructureDiagram()
     * @generated
     * @ordered
     */
    protected STAMPControlStructureDiagram controlStructureDiagram;

    /**
     * The cached value of the '{@link #getAnalysis() <em>Analysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getAnalysis()
     * @generated
     * @ordered
     */
    protected UCAAnalysis analysis;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCATableImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPNotationPackage.Literals.UCA_TABLE;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPControlStructureDiagram getControlStructureDiagram() {
        if (controlStructureDiagram != null && controlStructureDiagram.eIsProxy()) {
            InternalEObject oldControlStructureDiagram = (InternalEObject)controlStructureDiagram;
            controlStructureDiagram = (STAMPControlStructureDiagram)eResolveProxy(oldControlStructureDiagram);
            if (controlStructureDiagram != oldControlStructureDiagram) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM, oldControlStructureDiagram, controlStructureDiagram));
            }
        }
        return controlStructureDiagram;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPControlStructureDiagram basicGetControlStructureDiagram() {
        return controlStructureDiagram;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setControlStructureDiagram(STAMPControlStructureDiagram newControlStructureDiagram) {
        STAMPControlStructureDiagram oldControlStructureDiagram = controlStructureDiagram;
        controlStructureDiagram = newControlStructureDiagram;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM, oldControlStructureDiagram, controlStructureDiagram));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysis getAnalysis() {
        if (analysis != null && analysis.eIsProxy()) {
            InternalEObject oldAnalysis = (InternalEObject)analysis;
            analysis = (UCAAnalysis)eResolveProxy(oldAnalysis);
            if (analysis != oldAnalysis) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPNotationPackage.UCA_TABLE__ANALYSIS, oldAnalysis, analysis));
            }
        }
        return analysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysis basicGetAnalysis() {
        return analysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setAnalysis(UCAAnalysis newAnalysis) {
        UCAAnalysis oldAnalysis = analysis;
        analysis = newAnalysis;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.UCA_TABLE__ANALYSIS, oldAnalysis, analysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public EList<ControlAction> getControlActions() {
        return CONTROL_ACTION_CACHE.get(this);
    }

    /**
     * @generated NOT
     */
    protected static final EFeatureCache<UCATableImpl, EList<ControlAction>> CONTROL_ACTION_CACHE =
            new EFeatureCache.Global<>(STAMPNotationPackage.Literals.UCA_TABLE__CONTROL_ACTION,
                    UCATableImpl::calculateControlActions);

    /**
     * @generated NOT
     */
    protected EList<ControlAction> calculateControlActions() {
        STAMPControlStructureDiagram diagram = getControlStructureDiagram();
        UCAAnalysis analysis = getAnalysis();
        if ((diagram == null) || (analysis == null)) {
            return ECollections.emptyEList();
        }
        List<ControlAction> controlActionsOnDiagram = Lists.newArrayList(
                Iterators.filter(Iterators.concat(Iterators.transform(
                        Iterators.filter(EcoreUtil.getAllContents(diagram, true), STAMPShape.class),
                        shape -> shape.getModelElements().iterator())), ControlAction.class));
        return EObjectELists.unmodifiableEObjectEList(this, STAMPPackage.CONTROL_LINK__ACTION,
                analysis.getControlActions().stream()
                        .filter(m -> controlActionsOnDiagram.contains(m)
                                && !(m.getLink().getSource() instanceof LinkEnd)
                                && !(m.getLink().getTarget() instanceof LinkEnd))
                        .collect(Collectors.toList()));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public EList<UCAAnalysisResult> getResults() {
        return RESULT_CACHE.get(this);
    }

    /**
     * @generated NOT
     */
    protected static final EFeatureCache<UCATableImpl, EList<UCAAnalysisResult>> RESULT_CACHE =
            new EFeatureCache.Global<>(STAMPNotationPackage.Literals.UCA_TABLE__RESULT,
                    UCATableImpl::calculateResults);

    /**
     * @generated NOT
     */
    protected EList<UCAAnalysisResult> calculateResults() {
        List<ControlAction> controlActions = getControlActions();
        if (controlActions.isEmpty()) {
            return ECollections.emptyEList();
        }
        return EObjectELists.unmodifiableEObjectEList(this, STAMPPackage.UCA_ANALYSIS__RESULT,
                getAnalysis().getResults().stream()
                        .filter(result -> controlActions.contains(result.getControlAction()))
                        .collect(Collectors.toList()));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPNotationPackage.UCA_TABLE__EANNOTATIONS:
                return getEAnnotations();
            case STAMPNotationPackage.UCA_TABLE__MODEL_ELEMENT:
                return getModelElements();
            case STAMPNotationPackage.UCA_TABLE__OWNING_ELEMENT:
                if (resolve) return getOwningElement();
                return basicGetOwningElement();
            case STAMPNotationPackage.UCA_TABLE__OWNED_ELEMENT:
                return getOwnedElements();
            case STAMPNotationPackage.UCA_TABLE__TARGET_EDGE:
                return getTargetEdges();
            case STAMPNotationPackage.UCA_TABLE__SOURCE_EDGE:
                return getSourceEdges();
            case STAMPNotationPackage.UCA_TABLE__LOCAL_STYLE:
                return getLocalStyle();
            case STAMPNotationPackage.UCA_TABLE__SHARED_STYLE:
                if (resolve) return getSharedStyle();
                return basicGetSharedStyle();
            case STAMPNotationPackage.UCA_TABLE__BOUNDS:
                return getBounds();
            case STAMPNotationPackage.UCA_TABLE__NAME:
                return getName();
            case STAMPNotationPackage.UCA_TABLE__DOCUMENTATION:
                return getDocumentation();
            case STAMPNotationPackage.UCA_TABLE__RESOLUTION:
                return getResolution();
            case STAMPNotationPackage.UCA_TABLE__OWNER:
                if (resolve) return getOwner();
                return basicGetOwner();
            case STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM:
                if (resolve) return getControlStructureDiagram();
                return basicGetControlStructureDiagram();
            case STAMPNotationPackage.UCA_TABLE__ANALYSIS:
                if (resolve) return getAnalysis();
                return basicGetAnalysis();
            case STAMPNotationPackage.UCA_TABLE__CONTROL_ACTION:
                return getControlActions();
            case STAMPNotationPackage.UCA_TABLE__RESULT:
                return getResults();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPNotationPackage.UCA_TABLE__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__MODEL_ELEMENT:
                getModelElements().clear();
                getModelElements().addAll((Collection<? extends EObject>)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNING_ELEMENT:
                setOwningElement((DiagramElement)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNED_ELEMENT:
                getOwnedElements().clear();
                getOwnedElements().addAll((Collection<? extends DiagramElement>)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__TARGET_EDGE:
                getTargetEdges().clear();
                getTargetEdges().addAll((Collection<? extends Edge>)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__SOURCE_EDGE:
                getSourceEdges().clear();
                getSourceEdges().addAll((Collection<? extends Edge>)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__LOCAL_STYLE:
                setLocalStyle((Style)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__SHARED_STYLE:
                setSharedStyle((Style)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__BOUNDS:
                setBounds((Bounds)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__NAME:
                setName((String)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__DOCUMENTATION:
                setDocumentation((String)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__RESOLUTION:
                setResolution((Double)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNER:
                setOwner((EObject)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM:
                setControlStructureDiagram((STAMPControlStructureDiagram)newValue);
                return;
            case STAMPNotationPackage.UCA_TABLE__ANALYSIS:
                setAnalysis((UCAAnalysis)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPNotationPackage.UCA_TABLE__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPNotationPackage.UCA_TABLE__MODEL_ELEMENT:
                getModelElements().clear();
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNING_ELEMENT:
                setOwningElement((DiagramElement)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNED_ELEMENT:
                getOwnedElements().clear();
                return;
            case STAMPNotationPackage.UCA_TABLE__TARGET_EDGE:
                getTargetEdges().clear();
                return;
            case STAMPNotationPackage.UCA_TABLE__SOURCE_EDGE:
                getSourceEdges().clear();
                return;
            case STAMPNotationPackage.UCA_TABLE__LOCAL_STYLE:
                setLocalStyle((Style)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__SHARED_STYLE:
                setSharedStyle((Style)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__BOUNDS:
                setBounds((Bounds)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__NAME:
                setName(NAME_EDEFAULT);
                return;
            case STAMPNotationPackage.UCA_TABLE__DOCUMENTATION:
                setDocumentation(DOCUMENTATION_EDEFAULT);
                return;
            case STAMPNotationPackage.UCA_TABLE__RESOLUTION:
                setResolution(RESOLUTION_EDEFAULT);
                return;
            case STAMPNotationPackage.UCA_TABLE__OWNER:
                setOwner((EObject)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM:
                setControlStructureDiagram((STAMPControlStructureDiagram)null);
                return;
            case STAMPNotationPackage.UCA_TABLE__ANALYSIS:
                setAnalysis((UCAAnalysis)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPNotationPackage.UCA_TABLE__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPNotationPackage.UCA_TABLE__MODEL_ELEMENT:
                return !getModelElements().isEmpty();
            case STAMPNotationPackage.UCA_TABLE__OWNING_ELEMENT:
                return basicGetOwningElement() != null;
            case STAMPNotationPackage.UCA_TABLE__OWNED_ELEMENT:
                return !getOwnedElements().isEmpty();
            case STAMPNotationPackage.UCA_TABLE__TARGET_EDGE:
                return !getTargetEdges().isEmpty();
            case STAMPNotationPackage.UCA_TABLE__SOURCE_EDGE:
                return !getSourceEdges().isEmpty();
            case STAMPNotationPackage.UCA_TABLE__LOCAL_STYLE:
                return localStyle != null;
            case STAMPNotationPackage.UCA_TABLE__SHARED_STYLE:
                return sharedStyle != null;
            case STAMPNotationPackage.UCA_TABLE__BOUNDS:
                return bounds != null;
            case STAMPNotationPackage.UCA_TABLE__NAME:
                return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
            case STAMPNotationPackage.UCA_TABLE__DOCUMENTATION:
                return DOCUMENTATION_EDEFAULT == null ? documentation != null : !DOCUMENTATION_EDEFAULT.equals(documentation);
            case STAMPNotationPackage.UCA_TABLE__RESOLUTION:
                return resolution != RESOLUTION_EDEFAULT;
            case STAMPNotationPackage.UCA_TABLE__OWNER:
                return owner != null;
            case STAMPNotationPackage.UCA_TABLE__CONTROL_STRUCTURE_DIAGRAM:
                return controlStructureDiagram != null;
            case STAMPNotationPackage.UCA_TABLE__ANALYSIS:
                return analysis != null;
            case STAMPNotationPackage.UCA_TABLE__CONTROL_ACTION:
                return !getControlActions().isEmpty();
            case STAMPNotationPackage.UCA_TABLE__RESULT:
                return !getResults().isEmpty();
        }
        return eDynamicIsSet(featureID);
    }

} //UCATableImpl
