/**
 */
package net.astah.stpa.stamp.notation.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;

import net.astah.dd.di.Diagram;
import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.Edge;
import net.astah.dd.di.Shape;
import net.astah.notation.GraphicalShape;
import net.astah.notation.TableView;
import net.astah.stpa.stamp.notation.*;
import net.astah.stpa.stamp.notation.AccidentHazardSafetyConstraintTable;
import net.astah.stpa.stamp.notation.CountermeasureTable;
import net.astah.stpa.stamp.notation.HCFSummeryTable;
import net.astah.stpa.stamp.notation.HCFTable;
import net.astah.stpa.stamp.notation.PreconditionTable;
import net.astah.stpa.stamp.notation.STAMPCompartment;
import net.astah.stpa.stamp.notation.STAMPCompartmentableShape;
import net.astah.stpa.stamp.notation.STAMPComponentShape;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPGraphicalShape;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.STAMPTable;
import net.astah.stpa.stamp.notation.UCATable;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see net.astah.stpa.stamp.notation.STAMPNotationPackage
 * @generated
 */
public class STAMPNotationAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static STAMPNotationPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPNotationAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = STAMPNotationPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch that delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected STAMPNotationSwitch<Adapter> modelSwitch =
        new STAMPNotationSwitch<Adapter>() {
            @Override
            public Adapter caseSTAMPDiagramElement(STAMPDiagramElement object) {
                return createSTAMPDiagramElementAdapter();
            }
            @Override
            public Adapter caseSTAMPEdge(STAMPEdge object) {
                return createSTAMPEdgeAdapter();
            }
            @Override
            public Adapter caseSTAMPDiagram(STAMPDiagram object) {
                return createSTAMPDiagramAdapter();
            }
            @Override
            public Adapter caseSTAMPShape(STAMPShape object) {
                return createSTAMPShapeAdapter();
            }
            @Override
            public Adapter caseSTAMPLabel(STAMPLabel object) {
                return createSTAMPLabelAdapter();
            }
            @Override
            public Adapter caseSTAMPCompartment(STAMPCompartment object) {
                return createSTAMPCompartmentAdapter();
            }
            @Override
            public Adapter caseSTAMPCompartmentableShape(STAMPCompartmentableShape object) {
                return createSTAMPCompartmentableShapeAdapter();
            }
            @Override
            public Adapter caseSTAMPComponentShape(STAMPComponentShape object) {
                return createSTAMPComponentShapeAdapter();
            }
            @Override
            public Adapter caseSTAMPGraphicalShape(STAMPGraphicalShape object) {
                return createSTAMPGraphicalShapeAdapter();
            }
            @Override
            public Adapter caseSTAMPControlStructureDiagram(STAMPControlStructureDiagram object) {
                return createSTAMPControlStructureDiagramAdapter();
            }
            @Override
            public Adapter caseComponentExtractingTable(ComponentExtractingTable object) {
                return createComponentExtractingTableAdapter();
            }
            @Override
            public Adapter caseSTAMPTable(STAMPTable object) {
                return createSTAMPTableAdapter();
            }
            @Override
            public Adapter caseSTAMPControlLoopDiagram(STAMPControlLoopDiagram object) {
                return createSTAMPControlLoopDiagramAdapter();
            }
            @Override
            public Adapter casePreconditionTable(PreconditionTable object) {
                return createPreconditionTableAdapter();
            }
            @Override
            public Adapter caseAccidentHazardSafetyConstraintTable(AccidentHazardSafetyConstraintTable object) {
                return createAccidentHazardSafetyConstraintTableAdapter();
            }
            @Override
            public Adapter caseUCATable(UCATable object) {
                return createUCATableAdapter();
            }
            @Override
            public Adapter caseHCFTable(HCFTable object) {
                return createHCFTableAdapter();
            }
            @Override
            public Adapter caseHCFSummeryTable(HCFSummeryTable object) {
                return createHCFSummeryTableAdapter();
            }
            @Override
            public Adapter caseCountermeasureTable(CountermeasureTable object) {
                return createCountermeasureTableAdapter();
            }
            @Override
            public Adapter caseEModelElement(EModelElement object) {
                return createEModelElementAdapter();
            }
            @Override
            public Adapter caseDiagramElement(DiagramElement object) {
                return createDiagramElementAdapter();
            }
            @Override
            public Adapter caseNotation_DiagramElement(net.astah.notation.DiagramElement object) {
                return createNotation_DiagramElementAdapter();
            }
            @Override
            public Adapter caseEdge(Edge object) {
                return createEdgeAdapter();
            }
            @Override
            public Adapter caseNotation_Edge(net.astah.notation.Edge object) {
                return createNotation_EdgeAdapter();
            }
            @Override
            public Adapter caseShape(Shape object) {
                return createShapeAdapter();
            }
            @Override
            public Adapter caseDiagram(Diagram object) {
                return createDiagramAdapter();
            }
            @Override
            public Adapter caseNotation_Diagram(net.astah.notation.Diagram object) {
                return createNotation_DiagramAdapter();
            }
            @Override
            public Adapter caseNotation_Shape(net.astah.notation.Shape object) {
                return createNotation_ShapeAdapter();
            }
            @Override
            public Adapter caseGraphicalShape(GraphicalShape object) {
                return createGraphicalShapeAdapter();
            }
            @Override
            public Adapter caseTableView(TableView object) {
                return createTableViewAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object) {
                return createEObjectAdapter();
            }
        };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target) {
        return modelSwitch.doSwitch((EObject)target);
    }


    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPDiagramElement <em>STAMP Diagram Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPDiagramElement
     * @generated
     */
    public Adapter createSTAMPDiagramElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPEdge <em>STAMP Edge</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPEdge
     * @generated
     */
    public Adapter createSTAMPEdgeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPDiagram <em>STAMP Diagram</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPDiagram
     * @generated
     */
    public Adapter createSTAMPDiagramAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPShape <em>STAMP Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPShape
     * @generated
     */
    public Adapter createSTAMPShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPLabel <em>STAMP Label</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPLabel
     * @generated
     */
    public Adapter createSTAMPLabelAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPCompartment <em>STAMP Compartment</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPCompartment
     * @generated
     */
    public Adapter createSTAMPCompartmentAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPCompartmentableShape <em>STAMP Compartmentable Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPCompartmentableShape
     * @generated
     */
    public Adapter createSTAMPCompartmentableShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPControlStructureDiagram <em>STAMP Control Structure Diagram</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPControlStructureDiagram
     * @generated
     */
    public Adapter createSTAMPControlStructureDiagramAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.ComponentExtractingTable <em>Component Extracting Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.ComponentExtractingTable
     * @generated
     */
    public Adapter createComponentExtractingTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPGraphicalShape <em>STAMP Graphical Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPGraphicalShape
     * @generated
     */
    public Adapter createSTAMPGraphicalShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.PreconditionTable <em>Precondition Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.PreconditionTable
     * @generated
     */
    public Adapter createPreconditionTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPTable <em>STAMP Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPTable
     * @generated
     */
    public Adapter createSTAMPTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.AccidentHazardSafetyConstraintTable <em>Accident Hazard Safety Constraint Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.AccidentHazardSafetyConstraintTable
     * @generated
     */
    public Adapter createAccidentHazardSafetyConstraintTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.UCATable <em>UCA Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.UCATable
     * @generated
     */
    public Adapter createUCATableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPControlLoopDiagram <em>STAMP Control Loop Diagram</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPControlLoopDiagram
     * @generated
     */
    public Adapter createSTAMPControlLoopDiagramAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.HCFSummeryTable <em>HCF Summery Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.HCFSummeryTable
     * @generated
     */
    public Adapter createHCFSummeryTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.HCFTable <em>HCF Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.HCFTable
     * @generated
     */
    public Adapter createHCFTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.CountermeasureTable <em>Countermeasure Table</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.CountermeasureTable
     * @generated
     */
    public Adapter createCountermeasureTableAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.stpa.stamp.notation.STAMPComponentShape <em>STAMP Component Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.stpa.stamp.notation.STAMPComponentShape
     * @generated
     */
    public Adapter createSTAMPComponentShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.eclipse.emf.ecore.EModelElement
     * @generated
     */
    public Adapter createEModelElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.dd.di.DiagramElement <em>Diagram Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.dd.di.DiagramElement
     * @generated
     */
    public Adapter createDiagramElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.dd.di.Edge <em>Edge</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.dd.di.Edge
     * @generated
     */
    public Adapter createEdgeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.DiagramElement <em>Diagram Element</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.DiagramElement
     * @generated
     */
    public Adapter createNotation_DiagramElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.Edge <em>Edge</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.Edge
     * @generated
     */
    public Adapter createNotation_EdgeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.dd.di.Shape <em>Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.dd.di.Shape
     * @generated
     */
    public Adapter createShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.dd.di.Diagram <em>Diagram</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.dd.di.Diagram
     * @generated
     */
    public Adapter createDiagramAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.Shape <em>Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.Shape
     * @generated
     */
    public Adapter createNotation_ShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.GraphicalShape <em>Graphical Shape</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.GraphicalShape
     * @generated
     */
    public Adapter createGraphicalShapeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.Diagram <em>Diagram</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.Diagram
     * @generated
     */
    public Adapter createNotation_DiagramAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link net.astah.notation.TableView <em>Table View</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see net.astah.notation.TableView
     * @generated
     */
    public Adapter createTableViewAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //STAMPNotationAdapterFactory
