/**
 */
package net.astah.stpa.stamp.notation.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import net.astah.stpa.stamp.notation.*;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EObjectValidator;
import org.eclipse.emf.ecore.util.ExtendedMetaData;
import org.eclipse.emf.ecore.util.FeatureMapUtil;

import net.astah.stpa.stamp.notation.AccidentHazardSafetyConstraintTable;
import net.astah.stpa.stamp.notation.CountermeasureTable;
import net.astah.stpa.stamp.notation.HCFSummeryTable;
import net.astah.stpa.stamp.notation.HCFTable;
import net.astah.stpa.stamp.notation.PreconditionTable;
import net.astah.stpa.stamp.notation.STAMPCompartment;
import net.astah.stpa.stamp.notation.STAMPCompartmentableShape;
import net.astah.stpa.stamp.notation.STAMPComponentShape;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagram;
import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPGraphicalShape;
import net.astah.stpa.stamp.notation.STAMPLabel;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import net.astah.stpa.stamp.notation.STAMPNotationPlugin;
import net.astah.stpa.stamp.notation.STAMPShape;
import net.astah.stpa.stamp.notation.STAMPTable;
import net.astah.stpa.stamp.notation.UCATable;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see net.astah.stpa.stamp.notation.STAMPNotationPackage
 * @generated
 */
public class STAMPNotationValidator extends EObjectValidator {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final STAMPNotationValidator INSTANCE = new STAMPNotationValidator();

    /**
     * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.common.util.Diagnostic#getSource()
     * @see org.eclipse.emf.common.util.Diagnostic#getCode()
     * @generated
     */
    public static final String DIAGNOSTIC_SOURCE = "net.astah.stpa.stamp.notation";

    /**
     * A constant with a fixed name that can be used as the base value for additional hand written constants.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

    /**
     * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPNotationValidator() {
        super();
    }

    /**
     * Returns the package of this validator switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EPackage getEPackage() {
      return STAMPNotationPackage.eINSTANCE;
    }

    /**
     * Calls <code>validateXXX</code> for the corresponding classifier of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
        switch (classifierID) {
            case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT:
                return validateSTAMPDiagramElement((STAMPDiagramElement)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_EDGE:
                return validateSTAMPEdge((STAMPEdge)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_DIAGRAM:
                return validateSTAMPDiagram((STAMPDiagram)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_SHAPE:
                return validateSTAMPShape((STAMPShape)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_LABEL:
                return validateSTAMPLabel((STAMPLabel)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_COMPARTMENT:
                return validateSTAMPCompartment((STAMPCompartment)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_COMPARTMENTABLE_SHAPE:
                return validateSTAMPCompartmentableShape((STAMPCompartmentableShape)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_COMPONENT_SHAPE:
                return validateSTAMPComponentShape((STAMPComponentShape)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_GRAPHICAL_SHAPE:
                return validateSTAMPGraphicalShape((STAMPGraphicalShape)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_CONTROL_STRUCTURE_DIAGRAM:
                return validateSTAMPControlStructureDiagram((STAMPControlStructureDiagram)value, diagnostics, context);
            case STAMPNotationPackage.COMPONENT_EXTRACTING_TABLE:
                return validateComponentExtractingTable((ComponentExtractingTable)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_TABLE:
                return validateSTAMPTable((STAMPTable)value, diagnostics, context);
            case STAMPNotationPackage.STAMP_CONTROL_LOOP_DIAGRAM:
                return validateSTAMPControlLoopDiagram((STAMPControlLoopDiagram)value, diagnostics, context);
            case STAMPNotationPackage.PRECONDITION_TABLE:
                return validatePreconditionTable((PreconditionTable)value, diagnostics, context);
            case STAMPNotationPackage.ACCIDENT_HAZARD_SAFETY_CONSTRAINT_TABLE:
                return validateAccidentHazardSafetyConstraintTable((AccidentHazardSafetyConstraintTable)value, diagnostics, context);
            case STAMPNotationPackage.UCA_TABLE:
                return validateUCATable((UCATable)value, diagnostics, context);
            case STAMPNotationPackage.HCF_TABLE:
                return validateHCFTable((HCFTable)value, diagnostics, context);
            case STAMPNotationPackage.HCF_SUMMERY_TABLE:
                return validateHCFSummeryTable((HCFSummeryTable)value, diagnostics, context);
            case STAMPNotationPackage.COUNTERMEASURE_TABLE:
                return validateCountermeasureTable((CountermeasureTable)value, diagnostics, context);
            default:
                return true;
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPDiagramElement(STAMPDiagramElement stampDiagramElement, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampDiagramElement, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPEdge(STAMPEdge stampEdge, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampEdge, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPDiagram(STAMPDiagram stampDiagram, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampDiagram, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPShape(STAMPShape stampShape, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampShape, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPLabel(STAMPLabel stampLabel, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampLabel, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPCompartment(STAMPCompartment stampCompartment, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampCompartment, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPCompartmentableShape(STAMPCompartmentableShape stampCompartmentableShape, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampCompartmentableShape, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPControlStructureDiagram(STAMPControlStructureDiagram stampControlStructureDiagram, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampControlStructureDiagram, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateComponentExtractingTable(ComponentExtractingTable componentExtractingTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(componentExtractingTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPGraphicalShape(STAMPGraphicalShape stampGraphicalShape, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampGraphicalShape, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validatePreconditionTable(PreconditionTable preconditionTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(preconditionTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPTable(STAMPTable stampTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateAccidentHazardSafetyConstraintTable(AccidentHazardSafetyConstraintTable accidentHazardSafetyConstraintTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(accidentHazardSafetyConstraintTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateUCATable(UCATable ucaTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(ucaTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPControlLoopDiagram(STAMPControlLoopDiagram stampControlLoopDiagram, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampControlLoopDiagram, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateHCFSummeryTable(HCFSummeryTable hcfSummeryTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(hcfSummeryTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateHCFTable(HCFTable hcfTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(hcfTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateCountermeasureTable(CountermeasureTable countermeasureTable, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(countermeasureTable, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean validateSTAMPComponentShape(STAMPComponentShape stampComponentShape, DiagnosticChain diagnostics, Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(stampComponentShape, diagnostics, context);
    }

    /**
     * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return STAMPNotationPlugin.INSTANCE;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private String getRedefinitionDetail(EClass eClass, String featureName, String key) {
        List<EClass> eClasses = new ArrayList<EClass>();
        eClasses.add(eClass);
        eClasses.addAll(eClass.getEAllSuperTypes());
        String redefinitionDetail = null;
        for (Iterator<EClass> eClassesIterator = eClasses.iterator(); redefinitionDetail == null && eClassesIterator.hasNext(); ) {
            EAnnotation eAnnotation = eClassesIterator.next().getEAnnotation("duplicates");
            if (eAnnotation != null) {
                EAnnotation nestedEAnnotation = eAnnotation.getEAnnotation(featureName);
                if (nestedEAnnotation != null) {
                    redefinitionDetail = nestedEAnnotation.getDetails().get(key);
                }
            }
        }
        return redefinitionDetail;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected int getLowerBound(EObject eObject, EStructuralFeature eStructuralFeature) {
        String redefinitionDetail = getRedefinitionDetail(eObject.eClass(), eStructuralFeature.getName(), "lowerBound");
        if (redefinitionDetail != null && redefinitionDetail.length() > 0) {
            try {
                return Integer.parseInt(redefinitionDetail);
            }
            catch (Exception e) {
                // do nothing
            }
        }
        return eStructuralFeature.getLowerBound();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected int getUpperBound(EObject eObject, EStructuralFeature eStructuralFeature) {
        String redefinitionDetail = getRedefinitionDetail(eObject.eClass(), eStructuralFeature.getName(), "upperBound");
        if (redefinitionDetail != null && redefinitionDetail.length() > 0) {
            try {
                return Integer.parseInt(redefinitionDetail);
            }
            catch (Exception e) {
                // do nothing
            }
        }
        return eStructuralFeature.getUpperBound();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean isEcoreString(String key) {
        return super.isEcoreString(key)
            || "_UI_FeatureHasTooFewValues_diagnostic".equals(key)
            || "_UI_FeatureHasTooManyValues_diagnostic".equals(key)
            || "_UI_RequiredFeatureMustBeSet_diagnostic".equals(key);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected boolean validate_MultiplicityConforms(EObject eObject, EStructuralFeature eStructuralFeature, DiagnosticChain diagnostics, Map<Object, Object> context) {
        boolean result = true;
        if (eStructuralFeature.isMany()) {
            if (FeatureMapUtil.isFeatureMap(eStructuralFeature) && ExtendedMetaData.INSTANCE.isDocumentRoot(eObject.eClass())) {
                result = super.validate_MultiplicityConforms(eObject, eStructuralFeature, diagnostics, context);
            }
            else {
                int lowerBound = getLowerBound(eObject, eStructuralFeature);
                if (lowerBound > 0) {
                    int size = ((List<?>) eObject.eGet(eStructuralFeature)).size();
                    if (size < lowerBound) {
                        result = false;
                        if (diagnostics != null) {
                            diagnostics.add
                                (createDiagnostic
                                    (Diagnostic.ERROR,
                                    EObjectValidator.DIAGNOSTIC_SOURCE,
                                    EObjectValidator.EOBJECT__EVERY_MULTIPCITY_CONFORMS,
                                    "_UI_FeatureHasTooFewValues_diagnostic",
                                    new Object [] {
                                        getFeatureLabel(eStructuralFeature, context),
                                        getObjectLabel(eObject, context),
                                        size,
                                        lowerBound
                                    },
                                    new Object [] { eObject, eStructuralFeature },
                                    context));
                        }
                    }
                    int upperBound = getUpperBound(eObject, eStructuralFeature);
                    if (upperBound > 0 && size > upperBound) {
                        result = false;
                        if (diagnostics != null) {
                            diagnostics.add
                                (createDiagnostic
                                    (Diagnostic.ERROR,
                                    EObjectValidator.DIAGNOSTIC_SOURCE,
                                    EObjectValidator.EOBJECT__EVERY_MULTIPCITY_CONFORMS,
                                    "_UI_FeatureHasTooManyValues_diagnostic",
                                    new Object [] {
                                        getFeatureLabel(eStructuralFeature, context),
                                        getObjectLabel(eObject, context),
                                        size,
                                        upperBound
                                    },
                                    new Object [] { eObject, eStructuralFeature },
                                    context));
                        }
                    }
                }
                else {
                    int upperBound = getUpperBound(eObject, eStructuralFeature);
                    if (upperBound > 0) {
                        int size = ((List<?>) eObject.eGet(eStructuralFeature)).size();
                        if (size > upperBound) {
                            result = false;
                            if (diagnostics != null) {
                                diagnostics.add
                                    (createDiagnostic
                                        (Diagnostic.ERROR,
                                        EObjectValidator.DIAGNOSTIC_SOURCE,
                                        EObjectValidator.EOBJECT__EVERY_MULTIPCITY_CONFORMS,
                                        "_UI_FeatureHasTooManyValues_diagnostic",
                                        new Object [] {
                                            getFeatureLabel(eStructuralFeature, context),
                                            getObjectLabel(eObject, context),
                                            size,
                                            upperBound
                                        },
                                        new Object [] { eObject, eStructuralFeature },
                                        context));
                            }
                        }
                    }
                }
            }
        }
        else if (getLowerBound(eObject, eStructuralFeature) >= 1) {
            if (eStructuralFeature.isUnsettable() ? !eObject.eIsSet(eStructuralFeature) : eObject.eGet(eStructuralFeature, false) == null) {
                result = false;
                if (diagnostics != null) {
                    diagnostics.add
                        (createDiagnostic
                            (Diagnostic.ERROR,
                            EObjectValidator.DIAGNOSTIC_SOURCE,
                            EObjectValidator.EOBJECT__EVERY_MULTIPCITY_CONFORMS,
                            "_UI_RequiredFeatureMustBeSet_diagnostic",
                            new Object [] { getFeatureLabel(eStructuralFeature, context), getObjectLabel(eObject, context) },
                            new Object [] { eObject, eStructuralFeature },
                            context));
                }
            }
        }
        return result;
    }
} //STAMPNotationValidator
