package net.astah.stpa.stamp.ui.control;

import static javax.swing.JOptionPane.DEFAULT_OPTION;
import static javax.swing.JOptionPane.PLAIN_MESSAGE;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;

import net.astah.golf.control.Command;
import net.astah.golf.util.ResourceBundleList;
import net.astah.jomt.jsystem.PropertyManager;

/**
 * お問い合せダイアログを表示するコマンドです。
 */
public class InquiryInfoCommand extends Command {

    @Override
    public void execute() {
        final ResourceBundleList resource = PropertyManager.getJudeResourceBundle();
        final String title = resource.getString("jude.inquiry_information.title");
        final String message = resource.getString("jude.inquiry_information.message");
        final JTextArea textArea = new JTextArea(message);

        final JOptionPane pane = new JOptionPane(textArea, PLAIN_MESSAGE, DEFAULT_OPTION);
        final JDialog dialog = pane.createDialog(null, title);

        textArea.setEditable(false);
        textArea.setBackground(dialog.getBackground());

        dialog.pack();
        dialog.setVisible(true);
    }

}
