package net.astah.stpa.stamp.ui.menu.handler;

import java.awt.event.ActionEvent;
import java.util.List;

import net.astah.golf.widget.ISelection;
import net.astah.jomt.jcontrol.RedoCommand;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.ui.menu.annotation.Execute;
import net.astah.ui.menu.annotation.Handler;
import net.astah.ui.menu.annotation.KeyBinding;
import net.astah.ui.menu.annotation.MenuCommand;
import net.astah.ui.menu.annotation.MenuItem;
import net.astah.ui.menu.annotation.MenuItem.ItemKind;

/**
 * 編集をやり直します。
 */
@Handler(targets = { STAMPControlStructureDiagram.class,
        STAMPControlLoopDiagram.class })
@MenuItem(label = "%StampControlStructureDiagram_redo_label",
        iconURI = "platform:/plugin/net.astah.core.app/net/astah/jomt/resource/images/redo.png",
        tooltip = "%StampControlStructureDiagram_redo_tooltip",
        type = ItemKind.PUSH)
@MenuCommand(id = "stpa.RedoCommand",
        category = "edit.undo_redo")
@KeyBinding(keySequence = "control Y")
public class RedoHandler {

    /**
     * 編集をやり直すコマンドを実行します。
     * 
     * @param selection
     *            選択要素
     * @param params
     *            コマンドのパラメータ
     * @param e
     *            アクションイベント
     */
    @Execute
    public void execute(final ISelection selection, final List<String> params,
            final ActionEvent e) {
        final RedoCommand command = new RedoCommand();
        command.setUseTransaction(true);
        command.execute();
    }

}
