package net.astah.stpa.stamp.ui.menu.handler;

import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.JMenuItem;

import net.astah.dd.dg.Polyline;
import net.astah.dd.dg.util.DGStyleResolver;
import net.astah.golf.control.GolfAction;
import net.astah.golf.widget.ISelection;
import net.astah.golf.widget.swing.Selections;
import net.astah.ui.menu.annotation.AboutToShow;
import net.astah.ui.menu.annotation.CanExecute;
import net.astah.ui.menu.annotation.Execute;
import net.astah.ui.menu.annotation.Handler;
import net.astah.ui.menu.annotation.MenuCommand;
import net.astah.ui.menu.annotation.MenuItem;
import net.astah.ui.menu.annotation.MenuItem.ItemKind;

/**
 * 蛍光ペンの線の太さを設定します。
 */
@Handler(commands = "stpa.SetLineWidthToHighlighterCommand")
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style"),
        path = "LineWidth",
        label = "%StampControlStructureDiagram_lineWidth_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_tooltip",
        type = ItemKind.MENU)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "1"),
        path = "LineWidth." + "1",
        label = "%StampControlStructureDiagram_lineWidth_1_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_1_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "2"),
        path = "LineWidth." + "2",
        label = "%StampControlStructureDiagram_lineWidth_2_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_2_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "3"),
        path = "LineWidth." + "3",
        label = "%StampControlStructureDiagram_lineWidth_3_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_3_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "4"),
        path = "LineWidth." + "4",
        label = "%StampControlStructureDiagram_lineWidth_4_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_4_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "5"),
        path = "LineWidth." + "5",
        label = "%StampControlStructureDiagram_lineWidth_5_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_5_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "6"),
        path = "LineWidth." + "6",
        label = "%StampControlStructureDiagram_lineWidth_6_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_6_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "7"),
        path = "LineWidth." + "7",
        label = "%StampControlStructureDiagram_lineWidth_7_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_7_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "8"),
        path = "LineWidth." + "8",
        label = "%StampControlStructureDiagram_lineWidth_8_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_8_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "9"),
        path = "LineWidth." + "9",
        label = "%StampControlStructureDiagram_lineWidth_9_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_9_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "10"),
        path = "LineWidth." + "10",
        label = "%StampControlStructureDiagram_lineWidth_10_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_10_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "11"),
        path = "LineWidth." + "11",
        label = "%StampControlStructureDiagram_lineWidth_11_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_11_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "12"),
        path = "LineWidth." + "12",
        label = "%StampControlStructureDiagram_lineWidth_12_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_12_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "13"),
        path = "LineWidth." + "13",
        label = "%StampControlStructureDiagram_lineWidth_13_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_13_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "14"),
        path = "LineWidth." + "14",
        label = "%StampControlStructureDiagram_lineWidth_14_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_14_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "15"),
        path = "LineWidth." + "15",
        label = "%StampControlStructureDiagram_lineWidth_15_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_15_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "16"),
        path = "LineWidth." + "16",
        label = "%StampControlStructureDiagram_lineWidth_16_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_16_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "17"),
        path = "LineWidth." + "17",
        label = "%StampControlStructureDiagram_lineWidth_17_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_17_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "18"),
        path = "LineWidth." + "18",
        label = "%StampControlStructureDiagram_lineWidth_18_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_18_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "19"),
        path = "LineWidth." + "19",
        label = "%StampControlStructureDiagram_lineWidth_19_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_19_tooltip",
        type = ItemKind.CHECK)
@MenuItem(commands = @MenuCommand(id = "stpa.SetLineWidthToHighlighterCommand",
        category = "edit.style",
        parameters = "20"),
        path = "LineWidth." + "20",
        label = "%StampControlStructureDiagram_lineWidth_20_label",
        tooltip = "%StampControlStructureDiagram_lineWidth_20_tooltip",
        type = ItemKind.CHECK)
public class SetLineWidthToHighlighterHandler {

    /**
     * 蛍光ペンの線の太さを設定するコマンドを実行します。
     * 
     * @param selection
     *            選択要素
     * @param params
     *            コマンドのパラメータ
     * @param e
     *            アクションイベント
     */
    @Execute
    public void execute(final ISelection selection, final List<String> params,
            final ActionEvent e) {
        final GolfAction action = new GolfAction(
                "net.astah.jomt.jcontrol.SetMMLineWidth%" + params.get(0));
        action.actionPerformed(e);
    }

    /**
     * 蛍光ペンの線の太さを設定するコマンドが実行可能かどうか確認します。
     * 
     * @param selection
     *            選択要素
     * @return true コマンドが実行可能 / false コマンドが実行不可
     */
    @CanExecute
    public boolean canExecute(final ISelection selection) {
        // 選択要素がHighlighterのみの場合、true
        return !Selections.isEmpty(selection)
                && Selections.stream(selection).allMatch(object -> isHighlighter(object));
    }

    private boolean isHighlighter(final Object object) {
        if (object instanceof Polyline) {
            final Polyline polyline = (Polyline) object;
            final double strokeOpacity = DGStyleResolver.getInstance(polyline)
                    .resolveStrokeOpacity(polyline);
            return strokeOpacity < 1;
        }
        return false;
    }

    /**
     * メニュー表示の直前に、蛍光ペンの太さに該当するメニューをチェックします。
     * 
     * @param selection
     *            選択要素
     * @param menuItem
     *            表示するメニューアイテム
     * @param params
     *            コマンドに指定されているパラメータ
     */
    @AboutToShow
    public void aboutToShow(final ISelection selection, final JMenuItem menuItem,
            final List<String> params) {
        if (params.isEmpty()) {
            return;
        }
        if (Selections.size(selection) > 1) {
            return;
        }
        final boolean isSameLineWidth = isSameLineWidth(Selections.getFirstElement(selection),
                params.get(0));
        menuItem.setSelected(isSameLineWidth);
    }

    private boolean isSameLineWidth(final Object object, final String lineWidth) {
        if (object instanceof Polyline) {
            final Polyline polyline = (Polyline) object;
            final double strokeWidth = DGStyleResolver.getInstance(polyline)
                    .resolveStrokeWidth(polyline);
            return strokeWidth == Double.valueOf(lineWidth);
        }
        return false;
    }

}