package net.astah.stpa.stamp.ui.table;

import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

import net.astah.emf.edit.provider.swing.AdapterFactoryStyledLabelProvider;
import net.astah.golf.view.swing.IPropertySourceProvider;
import net.astah.golf.view.swing.MultiValueTableCellRenderer;
import net.astah.stpa.stamp.ui.view.swing.HCFScenarioDialogPanel;
import net.astah.table.ui.swing.DialogCellEditor;

/**
 * HCF表の各項目を表示するための{@link TableCellRenderer} と{@link TableCellEditor}
 * を提供するクラスです。<br/>
 * 主に、ヒントワードとシナリオの列をカスタマイズします.
 *
 */
public class HCFTableColumnProvider extends STPAGenericTableColumnProvider {

    private static final int HCF_SCENARIO__COLUMN = 3; // シナリオ列

    @Override
    protected TableCellRenderer createCellRenderer(
            final TuplePropertyColumnDescriptor columnDescriptor,
            final IPropertySourceProvider propertySourceProvider) {
        return new MultiValueTableCellRenderer(columnDescriptor, propertySourceProvider,
                new AdapterFactoryStyledLabelProvider(getAdapterFactory()));
    }

    @Override
    protected TableCellEditor createCellEditor(final TuplePropertyColumnDescriptor columnDescriptor,
            final IPropertySourceProvider propertySourceProvider) {
        final int index = columnDescriptor.getTuple().getIndex();
        if (index == HCF_SCENARIO__COLUMN) {
            final DialogCellEditor dialogCellEditor = new DialogCellEditor(columnDescriptor,
                    propertySourceProvider, new HCFScenarioDialogPanel(propertySourceProvider),
                    "HCF");
            dialogCellEditor.setClickCountToStart(2);
            return dialogCellEditor;
        } else {
            final ColumnCellEditor columnCellEditor = new ColumnCellEditor(columnDescriptor,
                    propertySourceProvider);
            return columnCellEditor;
        }
    }

}