package net.astah.stpa.stamp.ui.view;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.ecore.util.Switch;

import net.astah.jomt.jview.ModelPaneManager;
import net.astah.jomt.jview.proptab.ModelTabGroup;
import net.astah.stpa.stamp.notation.STAMPControlLoopDiagram;
import net.astah.stpa.stamp.notation.STAMPControlStructureDiagram;
import net.astah.stpa.stamp.notation.util.STAMPNotationSwitch;
import net.astah.stpa.stamp.ui.view.proptab.STAMPControlLoopDiagramPane;
import net.astah.stpa.stamp.ui.view.proptab.STAMPControlStructureDiagramPane;

/**
 * モデルによってプロパティタブを制御するマネージャークラスです。
 */
public class STAMPModelPaneManager extends ModelPaneManager {

    /**
     * モデルにしたがってタブを返します。
     */
    public static final class STPADiagramTabGroupSwitch
            extends STAMPNotationSwitch<Class<? extends ModelTabGroup>> {
        @Override
        public Class<? extends ModelTabGroup> caseSTAMPControlStructureDiagram(
                STAMPControlStructureDiagram object) {
            return STAMPControlStructureDiagramPane.class;
        }

        @Override
        public Class<? extends ModelTabGroup> caseSTAMPControlLoopDiagram(
                STAMPControlLoopDiagram object) {
            return STAMPControlLoopDiagramPane.class;
        }
    }

    private static final Collection<Switch<Class<? extends ModelTabGroup>>> stampPaneSwitches;
    static {
        List<Switch<Class<? extends ModelTabGroup>>> newPaneSwitches = new ArrayList<Switch<Class<? extends ModelTabGroup>>>();
        newPaneSwitches.add(new STPADiagramTabGroupSwitch());
        newPaneSwitches.add(new STAMPModelTabGroupSwitch());
        stampPaneSwitches = Collections.unmodifiableList(newPaneSwitches);
    }

    @Override
    protected Collection<Switch<Class<? extends ModelTabGroup>>> getPaneSwitches() {
        return stampPaneSwitches;
    }

}
