package net.astah.stpa.stamp.ui.view;

import java.awt.Frame;

import org.eclipse.emf.ecore.EClass;

import net.astah.jomt.jview.ProjectPropertyDialog;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;

/**
 * プロジェクトプロパティを設定するプロジェクトプロパティダイアログクラス(singleton)です。
 */
public class STAMPProjectPropertyDialog extends ProjectPropertyDialog {
    private static final long serialVersionUID = 9109430963841780250L;
    private static STAMPProjectPropertyDialog instance;

    protected STAMPProjectPropertyDialog(Frame owner, String optionKey) {
        super(owner, optionKey);
    }

    @Override
    protected EClass getKeyEClass(String key) {
        if ("stpa.color.component".equals(key)) {
            return STAMPNotationPackage.Literals.STAMP_COMPARTMENTABLE_SHAPE;
        }
        return super.getKeyEClass(key);
    }

    public static STAMPProjectPropertyDialog getInstance(Frame owner) {
        return getInstance(owner, "ui.project_properties.group");
    }

    public static STAMPProjectPropertyDialog getInstance(Frame owner, String optionKey) {
        instance = new STAMPProjectPropertyDialog(owner, optionKey);
        instance.resetPanels();
        return instance;
    }
}
