package net.astah.stpa.stamp.ui.view;

import java.awt.Component;

import net.astah.golf.view.UIView;
import net.astah.golf.widget.swing.SwingComponent;
import net.astah.jmodel.Project;
import net.astah.jomt.jview.ProjectView;
import net.astah.jomt.jview.ProjectViewPeer;

/**
 * STAMPプロジェクトビューを管理するクラスです。
 */
public class STAMPProjectView extends ProjectView {

    protected AnalysisProcedureView analysisProcedureView;

    public STAMPProjectView(Project p) {
        super(p);
    }

    @Override
    protected void createEachViews() {
        super.createEachViews();

        // insert Analysis Procedure View
        analysisProcedureView = new AnalysisProcedureView(project.doc);
        insertUIView(0, analysisProcedureView);
    }

    @Override
    public UIView getSelectedUIViewTab() {

        Component component = ((ProjectViewPeer) uiViewPeer).getSelectedUIViewTab();

        if (analysisProcedureView != null
                && ((SwingComponent) analysisProcedureView.getBaseComponent())
                        .getComponent() == component) {
            return analysisProcedureView;
        }
        return super.getSelectedUIViewTab();
    }
}
