package net.astah.stpa.stamp.ui.view.proptab;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;

import net.astah.emf.common.notify.EFeaturePath;
import net.astah.emf.edit.provider.swing.AdapterFactoryContentProvider;
import net.astah.emf.edit.provider.swing.FeaturePathContentProvider;
import net.astah.emf.edit.provider.swing.TransactionalFeaturePathContentProvider;
import net.astah.stpa.stamp.STAMPFactory;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.Signal;
import net.astah.stpa.stamp.ui.Messages;

/**
 * フィードバックリンクに関係するフィードバック を表示するプロパティタブの実装です。
 */
public class STAMPLinkFeedbackTab extends STAMPLinkSignalTab {

    private static final long serialVersionUID = 4093681341448653185L;

    @Override
    public String getTabName() {
        return Messages.projectview_feedback_tab_title;
    }

    @Override
    protected AdapterFactoryContentProvider createContentProvider(
            final EditingDomain domain,
            final AdapterFactory adapterFactory) {
        final FeaturePathContentProvider contentProvider = (domain instanceof TransactionalEditingDomain)
                ? new TransactionalFeaturePathContentProvider(
                        (TransactionalEditingDomain) domain, adapterFactory)
                : new FeaturePathContentProvider(adapterFactory);
        contentProvider.addPath(EFeaturePath.build(STAMPPackage.Literals.FEEDBACK_LINK__FEEDBACK));
        contentProvider.addPath(EFeaturePath.build(STAMPPackage.Literals.FEEDBACK_LINK__FEEDBACK));
        return contentProvider;
    }

    @Override
    protected Signal createSignalAction() {
        return STAMPFactory.eINSTANCE.createFeedback();
    }

}
