package net.astah.stpa.stamp.ui.view.proptab;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JPanel;

import net.astah.golf.widget.swing.IStructuredViewerAdapter;
import net.astah.jomt.jview.proptab.PropertySourceTab;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.ui.Messages;

/**
 * ノートのプロパティのベースタブを実装します。
 */
public class STAMPNoteBaseTab extends PropertySourceTab implements IStructuredViewerAdapter {

    private static final long serialVersionUID = -7183233128455250650L;

    @Override
    protected void initPanel() {
        super.initPanel();

        if (baseItemsPanel == null) {
            return;
        }

        initTextPanel();
    }

    private void initTextPanel() {
        JPanel textPanel = new JPanel(new BorderLayout());
        textPanel.add(BorderLayout.NORTH, new JLabel(Messages.projectview_base_tab_text_label));
        Component cellEditorComponent = createPropertyCellEditorComponent(
                STAMPPackage.Literals.NOTE__BODY);
        textPanel.add(BorderLayout.CENTER, cellEditorComponent);

        add("Center", textPanel);
    }

    @Override
    public String getTabName() {
        return Messages.projectview_base_tab_title;
    }
}
