/**
 */
package net.astah.stpa.stamp;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.Component#getNestedComponents <em>Nested Component</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Component#getProcessModel <em>Process Model</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Component#isAnalysisTarget <em>Is Analysis Target</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Component#getResponsibility <em>Responsibility</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Component#getRemarks <em>Remarks</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.Component#getOwner <em>Owner</em>}</li>
 * </ul>
 *
 * @see net.astah.stpa.stamp.STAMPPackage#getComponent()
 * @model
 * @generated
 */
public interface Component extends LinkableElement {
    /**
     * Returns the value of the '<em><b>Owner</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.ControlStructure#getComponents <em>Component</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Owner</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Owner</em>' container reference.
     * @see #setOwner(ControlStructure)
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_Owner()
     * @see net.astah.stpa.stamp.ControlStructure#getComponents
     * @model opposite="component" transient="false" ordered="false"
     * @generated
     */
    ControlStructure getOwner();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Component#getOwner <em>Owner</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Owner</em>' container reference.
     * @see #getOwner()
     * @generated
     */
    void setOwner(ControlStructure value);

    /**
     * Returns the value of the '<em><b>Nested Component</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Component}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Nested Component</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Nested Component</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_NestedComponent()
     * @model containment="true" resolveProxies="true"
     * @generated
     */
    EList<Component> getNestedComponents();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Component} and appends it to the '<em><b>Nested Component</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Component}.
     * @see #getNestedComponents()
     * @generated
     */
    Component createNestedComponent();

    /**
     * Returns the value of the '<em><b>Process Model</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.ProcessModel#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Process Model</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Process Model</em>' containment reference.
     * @see #setProcessModel(ProcessModel)
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_ProcessModel()
     * @see net.astah.stpa.stamp.ProcessModel#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true" ordered="false"
     * @generated
     */
    ProcessModel getProcessModel();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Component#getProcessModel <em>Process Model</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Process Model</em>' containment reference.
     * @see #getProcessModel()
     * @generated
     */
    void setProcessModel(ProcessModel value);

    /**
     * Creates a new {@link net.astah.stpa.stamp.ProcessModel} and sets the '<em><b>Process Model</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.ProcessModel}.
     * @see #getProcessModel()
     * @generated
     */
    ProcessModel createProcessModel();

    /**
     * Returns the value of the '<em><b>Is Analysis Target</b></em>' attribute.
     * The default value is <code>"false"</code>.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Analysis Target</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Analysis Target</em>' attribute.
     * @see #setIsAnalysisTarget(boolean)
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_IsAnalysisTarget()
     * @model default="false" required="true" ordered="false"
     * @generated
     */
    boolean isAnalysisTarget();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Component#isAnalysisTarget <em>Is Analysis Target</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Is Analysis Target</em>' attribute.
     * @see #isAnalysisTarget()
     * @generated
     */
    void setIsAnalysisTarget(boolean value);

    /**
     * Returns the value of the '<em><b>Responsibility</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Responsibility</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Responsibility</em>' attribute.
     * @see #setResponsibility(String)
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_Responsibility()
     * @model ordered="false"
     * @generated
     */
    String getResponsibility();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Component#getResponsibility <em>Responsibility</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Responsibility</em>' attribute.
     * @see #getResponsibility()
     * @generated
     */
    void setResponsibility(String value);

    /**
     * Returns the value of the '<em><b>Remarks</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Remarks</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Remarks</em>' attribute.
     * @see #setRemarks(String)
     * @see net.astah.stpa.stamp.STAMPPackage#getComponent_Remarks()
     * @model ordered="false"
     * @generated
     */
    String getRemarks();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.Component#getRemarks <em>Remarks</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Remarks</em>' attribute.
     * @see #getRemarks()
     * @generated
     */
    void setRemarks(String value);

} // Component
