/**
 */
package net.astah.stpa.stamp;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>STPA Analysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getAccidents <em>Accident</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getHazards <em>Hazard</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getSafetyConstraints <em>Safety Constraint</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getPreconditions <em>Precondition</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getControlStructures <em>Control Structure</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getCountermeasures <em>Countermeasure</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getHazardCausalFactors <em>Hazard Causal Factor</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getUnsafeControlActions <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getUCAGuideWordSets <em>UCA Guide Word Set</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getHCFHintWordSets <em>HCF Hint Word Set</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getOwner <em>Owner</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getUcaAnalysis <em>Uca Analysis</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.STPAAnalysis#getHcfAnalysis <em>Hcf Analysis</em>}</li>
 * </ul>
 *
 * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis()
 * @model
 * @generated
 */
public interface STPAAnalysis extends NamedElement {
    /**
     * Returns the value of the '<em><b>Accident</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Accident}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Accident#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Accident</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Accident</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_Accident()
     * @see net.astah.stpa.stamp.Accident#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Accident> getAccidents();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Accident} and appends it to the '<em><b>Accident</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Accident}.
     * @see #getAccidents()
     * @generated
     */
    Accident createAccident();

    /**
     * Returns the value of the '<em><b>Hazard</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Hazard}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Hazard#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Hazard</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hazard</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_Hazard()
     * @see net.astah.stpa.stamp.Hazard#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Hazard> getHazards();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Hazard} and appends it to the '<em><b>Hazard</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Hazard}.
     * @see #getHazards()
     * @generated
     */
    Hazard createHazard();

    /**
     * Returns the value of the '<em><b>Safety Constraint</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.SafetyConstraint}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.SafetyConstraint#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Safety Constraint</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Safety Constraint</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_SafetyConstraint()
     * @see net.astah.stpa.stamp.SafetyConstraint#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<SafetyConstraint> getSafetyConstraints();

    /**
     * Creates a new {@link net.astah.stpa.stamp.SafetyConstraint} and appends it to the '<em><b>Safety Constraint</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.SafetyConstraint}.
     * @see #getSafetyConstraints()
     * @generated
     */
    SafetyConstraint createSafetyConstraint();

    /**
     * Returns the value of the '<em><b>Precondition</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Precondition}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Precondition#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Precondition</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Precondition</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_Precondition()
     * @see net.astah.stpa.stamp.Precondition#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Precondition> getPreconditions();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Precondition} and appends it to the '<em><b>Precondition</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Precondition}.
     * @see #getPreconditions()
     * @generated
     */
    Precondition createPrecondition();

    /**
     * Returns the value of the '<em><b>Countermeasure</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.Countermeasure}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.Countermeasure#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Countermeasure</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Countermeasure</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_Countermeasure()
     * @see net.astah.stpa.stamp.Countermeasure#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<Countermeasure> getCountermeasures();

    /**
     * Creates a new {@link net.astah.stpa.stamp.Countermeasure} and appends it to the '<em><b>Countermeasure</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.Countermeasure}.
     * @see #getCountermeasures()
     * @generated
     */
    Countermeasure createCountermeasure();

    /**
     * Returns the value of the '<em><b>UCA Guide Word Set</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.UCAGuideWordSet}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.UCAGuideWordSet#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>UCA Guide Word Set</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>UCA Guide Word Set</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_UCAGuideWordSet()
     * @see net.astah.stpa.stamp.UCAGuideWordSet#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true" required="true"
     * @generated
     */
    EList<UCAGuideWordSet> getUCAGuideWordSets();

    /**
     * Creates a new {@link net.astah.stpa.stamp.UCAGuideWordSet} and appends it to the '<em><b>UCA Guide Word Set</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.UCAGuideWordSet}.
     * @see #getUCAGuideWordSets()
     * @generated
     */
    UCAGuideWordSet createUCAGuideWordSet();

    /**
     * Returns the value of the '<em><b>HCF Hint Word Set</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.HCFHintWordSet}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.HCFHintWordSet#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>HCF Hint Word Set</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>HCF Hint Word Set</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_HCFHintWordSet()
     * @see net.astah.stpa.stamp.HCFHintWordSet#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true" required="true"
     * @generated
     */
    EList<HCFHintWordSet> getHCFHintWordSets();

    /**
     * Creates a new {@link net.astah.stpa.stamp.HCFHintWordSet} and appends it to the '<em><b>HCF Hint Word Set</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.HCFHintWordSet}.
     * @see #getHCFHintWordSets()
     * @generated
     */
    HCFHintWordSet createHCFHintWordSet();

    /**
     * Returns the value of the '<em><b>Owner</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Owner</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Owner</em>' reference.
     * @see #setOwner(EObject)
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_Owner()
     * @model ordered="false"
     * @generated
     */
    EObject getOwner();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.STPAAnalysis#getOwner <em>Owner</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Owner</em>' reference.
     * @see #getOwner()
     * @generated
     */
    void setOwner(EObject value);

    /**
     * Returns the value of the '<em><b>Uca Analysis</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.UCAAnalysis#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Uca Analysis</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Uca Analysis</em>' containment reference.
     * @see #setUcaAnalysis(UCAAnalysis)
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_UcaAnalysis()
     * @see net.astah.stpa.stamp.UCAAnalysis#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true" ordered="false"
     * @generated
     */
    UCAAnalysis getUcaAnalysis();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.STPAAnalysis#getUcaAnalysis <em>Uca Analysis</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Uca Analysis</em>' containment reference.
     * @see #getUcaAnalysis()
     * @generated
     */
    void setUcaAnalysis(UCAAnalysis value);

    /**
     * Creates a new {@link net.astah.stpa.stamp.UCAAnalysis} and sets the '<em><b>Uca Analysis</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.UCAAnalysis}.
     * @see #getUcaAnalysis()
     * @generated
     */
    UCAAnalysis createUcaAnalysis();

    /**
     * Returns the value of the '<em><b>Unsafe Control Action</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.UnsafeControlAction}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.UnsafeControlAction#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Unsafe Control Action</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Unsafe Control Action</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_UnsafeControlAction()
     * @see net.astah.stpa.stamp.UnsafeControlAction#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<UnsafeControlAction> getUnsafeControlActions();

    /**
     * Creates a new {@link net.astah.stpa.stamp.UnsafeControlAction} and appends it to the '<em><b>Unsafe Control Action</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.UnsafeControlAction}.
     * @see #getUnsafeControlActions()
     * @generated
     */
    UnsafeControlAction createUnsafeControlAction();

    /**
     * Returns the value of the '<em><b>Hcf Analysis</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.HCFAnalysis#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Hcf Analysis</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hcf Analysis</em>' containment reference.
     * @see #setHcfAnalysis(HCFAnalysis)
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_HcfAnalysis()
     * @see net.astah.stpa.stamp.HCFAnalysis#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true" ordered="false"
     * @generated
     */
    HCFAnalysis getHcfAnalysis();

    /**
     * Sets the value of the '{@link net.astah.stpa.stamp.STPAAnalysis#getHcfAnalysis <em>Hcf Analysis</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Hcf Analysis</em>' containment reference.
     * @see #getHcfAnalysis()
     * @generated
     */
    void setHcfAnalysis(HCFAnalysis value);

    /**
     * Creates a new {@link net.astah.stpa.stamp.HCFAnalysis} and sets the '<em><b>Hcf Analysis</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.HCFAnalysis}.
     * @see #getHcfAnalysis()
     * @generated
     */
    HCFAnalysis createHcfAnalysis();

    /**
     * Returns the value of the '<em><b>Hazard Causal Factor</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.HazardCausalFactor}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.HazardCausalFactor#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Hazard Causal Factor</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Hazard Causal Factor</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_HazardCausalFactor()
     * @see net.astah.stpa.stamp.HazardCausalFactor#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<HazardCausalFactor> getHazardCausalFactors();

    /**
     * Creates a new {@link net.astah.stpa.stamp.HazardCausalFactor} and appends it to the '<em><b>Hazard Causal Factor</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.HazardCausalFactor}.
     * @see #getHazardCausalFactors()
     * @generated
     */
    HazardCausalFactor createHazardCausalFactor();

    /**
     * Returns the value of the '<em><b>Control Structure</b></em>' containment reference list.
     * The list contents are of type {@link net.astah.stpa.stamp.ControlStructure}.
     * It is bidirectional and its opposite is '{@link net.astah.stpa.stamp.ControlStructure#getOwner <em>Owner</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Control Structure</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Control Structure</em>' containment reference list.
     * @see net.astah.stpa.stamp.STAMPPackage#getSTPAAnalysis_ControlStructure()
     * @see net.astah.stpa.stamp.ControlStructure#getOwner
     * @model opposite="owner" containment="true" resolveProxies="true"
     * @generated
     */
    EList<ControlStructure> getControlStructures();

    /**
     * Creates a new {@link net.astah.stpa.stamp.ControlStructure} and appends it to the '<em><b>Control Structure</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The new {@link net.astah.stpa.stamp.ControlStructure}.
     * @see #getControlStructures()
     * @generated
     */
    ControlStructure createControlStructure();

} // STPAAnalysis
