/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;

import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.HCFAnalysisResult;
import net.astah.stpa.stamp.HCFHintWord;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.UnsafeControlAction;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.SubsetSupersetEObjectContainmentWithInverseEList;
import org.eclipse.uml2.common.util.SubsetSupersetEObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HCF Analysis Result</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.HCFAnalysisResultImpl#getResultElements <em>Result Element</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HCFAnalysisResultImpl#getHazardCausalFactors <em>Hazard Causal Factor</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HCFAnalysisResultImpl#getUnsafeControlAction <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HCFAnalysisResultImpl#getHintWord <em>Hint Word</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HCFAnalysisResultImpl#getOwnedNotes <em>Owned Note</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HCFAnalysisResultImpl extends ElementImpl implements HCFAnalysisResult {
    /**
     * The cached value of the '{@link #getResultElements() <em>Result Element</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getResultElements()
     * @generated
     * @ordered
     */
    protected EList<Element> resultElements;

    /**
     * The cached value of the '{@link #getHazardCausalFactors() <em>Hazard Causal Factor</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHazardCausalFactors()
     * @generated
     * @ordered
     */
    protected EList<HazardCausalFactor> hazardCausalFactors;

    /**
     * The cached value of the '{@link #getUnsafeControlAction() <em>Unsafe Control Action</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUnsafeControlAction()
     * @generated
     * @ordered
     */
    protected UnsafeControlAction unsafeControlAction;

    /**
     * The cached value of the '{@link #getHintWord() <em>Hint Word</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHintWord()
     * @generated
     * @ordered
     */
    protected HCFHintWord hintWord;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HCFAnalysisResultImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.HCF_ANALYSIS_RESULT;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Element> getResultElements() {
        if (resultElements == null) {
            resultElements = new SubsetSupersetEObjectResolvingEList<Element>(Element.class, this, STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT, null, RESULT_ELEMENT_ESUBSETS);
        }
        return resultElements;
    }

    /**
     * The array of subset feature identifiers for the '{@link #getResultElements() <em>Result Element</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getResultElements()
     * @generated
     * @ordered
     */
    protected static final int[] RESULT_ELEMENT_ESUBSETS = new int[] {STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR, STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE};

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<HazardCausalFactor> getHazardCausalFactors() {
        if (hazardCausalFactors == null) {
            hazardCausalFactors = new SubsetSupersetEObjectResolvingEList<HazardCausalFactor>(HazardCausalFactor.class, this, STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR, HAZARD_CAUSAL_FACTOR_ESUPERSETS, null);
        }
        return hazardCausalFactors;
    }

    /**
     * The array of superset feature identifiers for the '{@link #getHazardCausalFactors() <em>Hazard Causal Factor</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHazardCausalFactors()
     * @generated
     * @ordered
     */
    protected static final int[] HAZARD_CAUSAL_FACTOR_ESUPERSETS = new int[] {STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT};

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlAction getUnsafeControlAction() {
        if (unsafeControlAction != null && unsafeControlAction.eIsProxy()) {
            InternalEObject oldUnsafeControlAction = (InternalEObject)unsafeControlAction;
            unsafeControlAction = (UnsafeControlAction)eResolveProxy(oldUnsafeControlAction);
            if (unsafeControlAction != oldUnsafeControlAction) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, oldUnsafeControlAction, unsafeControlAction));
            }
        }
        return unsafeControlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlAction basicGetUnsafeControlAction() {
        return unsafeControlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setUnsafeControlAction(UnsafeControlAction newUnsafeControlAction) {
        UnsafeControlAction oldUnsafeControlAction = unsafeControlAction;
        unsafeControlAction = newUnsafeControlAction;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, oldUnsafeControlAction, unsafeControlAction));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFHintWord getHintWord() {
        if (hintWord != null && hintWord.eIsProxy()) {
            InternalEObject oldHintWord = (InternalEObject)hintWord;
            hintWord = (HCFHintWord)eResolveProxy(oldHintWord);
            if (hintWord != oldHintWord) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD, oldHintWord, hintWord));
            }
        }
        return hintWord;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFHintWord basicGetHintWord() {
        return hintWord;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setHintWord(HCFHintWord newHintWord) {
        HCFHintWord oldHintWord = hintWord;
        hintWord = newHintWord;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD, oldHintWord, hintWord));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<Note> getOwnedNotes() {
        if (ownedNotes == null) {
            ownedNotes = new SubsetSupersetEObjectContainmentWithInverseEList.Resolving<Note>(Note.class, this, STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE, OWNED_NOTE_ESUPERSETS, null, STAMPPackage.NOTE__OWNER);
        }
        return ownedNotes;
    }

    /**
     * The array of superset feature identifiers for the '{@link #getOwnedNotes() <em>Owned Note</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getOwnedNotes()
     * @generated
     * @ordered
     */
    protected static final int[] OWNED_NOTE_ESUPERSETS = new int[] {STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT};

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Note createOwnedNote() {
        Note newOwnedNote = (Note) create(STAMPPackage.Literals.NOTE);
        getOwnedNotes().add(newOwnedNote);
        return newOwnedNote;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetOwnedNotes() {
        return ownedNotes != null && !ownedNotes.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT:
                return getResultElements();
            case STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR:
                return getHazardCausalFactors();
            case STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                if (resolve) return getUnsafeControlAction();
                return basicGetUnsafeControlAction();
            case STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD:
                if (resolve) return getHintWord();
                return basicGetHintWord();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT:
                getResultElements().clear();
                getResultElements().addAll((Collection<? extends Element>)newValue);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR:
                getHazardCausalFactors().clear();
                getHazardCausalFactors().addAll((Collection<? extends HazardCausalFactor>)newValue);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                setUnsafeControlAction((UnsafeControlAction)newValue);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD:
                setHintWord((HCFHintWord)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT:
                getResultElements().clear();
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR:
                getHazardCausalFactors().clear();
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                setUnsafeControlAction((UnsafeControlAction)null);
                return;
            case STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD:
                setHintWord((HCFHintWord)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.HCF_ANALYSIS_RESULT__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.HCF_ANALYSIS_RESULT__OWNED_NOTE:
                return isSetOwnedNotes();
            case STAMPPackage.HCF_ANALYSIS_RESULT__RESULT_ELEMENT:
                return resultElements != null && !resultElements.isEmpty();
            case STAMPPackage.HCF_ANALYSIS_RESULT__HAZARD_CAUSAL_FACTOR:
                return hazardCausalFactors != null && !hazardCausalFactors.isEmpty();
            case STAMPPackage.HCF_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                return unsafeControlAction != null;
            case STAMPPackage.HCF_ANALYSIS_RESULT__HINT_WORD:
                return hintWord != null;
        }
        return eDynamicIsSet(featureID);
    }

} //HCFAnalysisResultImpl
