/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;
import net.astah.stpa.stamp.Accident;
import net.astah.stpa.stamp.Hazard;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;

import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.SafetyConstraint;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hazard</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardImpl#getOwner <em>Owner</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardImpl#getSafetyConstraints <em>Safety Constraint</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.HazardImpl#getAccidents <em>Accident</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HazardImpl extends IdentifiedElementImpl implements Hazard {
    /**
     * The cached value of the '{@link #getSafetyConstraints() <em>Safety Constraint</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSafetyConstraints()
     * @generated
     * @ordered
     */
    protected EList<SafetyConstraint> safetyConstraints;
    /**
     * The cached value of the '{@link #getAccidents() <em>Accident</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getAccidents()
     * @generated
     * @ordered
     */
    protected EList<Accident> accidents;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected HazardImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.HAZARD;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis getOwner() {
        if (eContainerFeatureID() != STAMPPackage.HAZARD__OWNER) return null;
        return (STPAAnalysis)eContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STPAAnalysis basicGetOwner() {
        if (eContainerFeatureID() != STAMPPackage.HAZARD__OWNER) return null;
        return (STPAAnalysis)eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetOwner(STPAAnalysis newOwner, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newOwner, STAMPPackage.HAZARD__OWNER, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setOwner(STPAAnalysis newOwner) {
        if (newOwner != eInternalContainer() || (eContainerFeatureID() != STAMPPackage.HAZARD__OWNER && newOwner != null)) {
            if (EcoreUtil.isAncestor(this, newOwner))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newOwner != null)
                msgs = ((InternalEObject)newOwner).eInverseAdd(this, STAMPPackage.STPA_ANALYSIS__HAZARD, STPAAnalysis.class, msgs);
            msgs = basicSetOwner(newOwner, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.HAZARD__OWNER, newOwner, newOwner));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<SafetyConstraint> getSafetyConstraints() {
        if (safetyConstraints == null) {
            safetyConstraints = new EObjectWithInverseResolvingEList.ManyInverse<SafetyConstraint>(SafetyConstraint.class, this, STAMPPackage.HAZARD__SAFETY_CONSTRAINT, STAMPPackage.SAFETY_CONSTRAINT__HAZARD);
        }
        return safetyConstraints;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Accident> getAccidents() {
        if (accidents == null) {
            accidents = new EObjectWithInverseResolvingEList.ManyInverse<Accident>(Accident.class, this, STAMPPackage.HAZARD__ACCIDENT, STAMPPackage.ACCIDENT__HAZARD);
        }
        return accidents;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HAZARD__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HAZARD__OWNER:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetOwner((STPAAnalysis)otherEnd, msgs);
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getSafetyConstraints()).basicAdd(otherEnd, msgs);
            case STAMPPackage.HAZARD__ACCIDENT:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getAccidents()).basicAdd(otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD__OWNER:
                return basicSetOwner(null, msgs);
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                return ((InternalEList<?>)getSafetyConstraints()).basicRemove(otherEnd, msgs);
            case STAMPPackage.HAZARD__ACCIDENT:
                return ((InternalEList<?>)getAccidents()).basicRemove(otherEnd, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case STAMPPackage.HAZARD__OWNER:
                return eInternalContainer().eInverseRemove(this, STAMPPackage.STPA_ANALYSIS__HAZARD, STPAAnalysis.class, msgs);
        }
        return eDynamicBasicRemoveFromContainer(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.HAZARD__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.HAZARD__ID:
                return getId();
            case STAMPPackage.HAZARD__DESCRIPTION:
                return getDescription();
            case STAMPPackage.HAZARD__OWNER:
                if (resolve) return getOwner();
                return basicGetOwner();
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                return getSafetyConstraints();
            case STAMPPackage.HAZARD__ACCIDENT:
                return getAccidents();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.HAZARD__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.HAZARD__ID:
                setId((String)newValue);
                return;
            case STAMPPackage.HAZARD__DESCRIPTION:
                setDescription((String)newValue);
                return;
            case STAMPPackage.HAZARD__OWNER:
                setOwner((STPAAnalysis)newValue);
                return;
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                getSafetyConstraints().clear();
                getSafetyConstraints().addAll((Collection<? extends SafetyConstraint>)newValue);
                return;
            case STAMPPackage.HAZARD__ACCIDENT:
                getAccidents().clear();
                getAccidents().addAll((Collection<? extends Accident>)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.HAZARD__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.HAZARD__ID:
                setId(ID_EDEFAULT);
                return;
            case STAMPPackage.HAZARD__DESCRIPTION:
                setDescription(DESCRIPTION_EDEFAULT);
                return;
            case STAMPPackage.HAZARD__OWNER:
                setOwner((STPAAnalysis)null);
                return;
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                getSafetyConstraints().clear();
                return;
            case STAMPPackage.HAZARD__ACCIDENT:
                getAccidents().clear();
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.HAZARD__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.HAZARD__OWNED_NOTE:
                return ownedNotes != null && !ownedNotes.isEmpty();
            case STAMPPackage.HAZARD__ID:
                return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
            case STAMPPackage.HAZARD__DESCRIPTION:
                return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
            case STAMPPackage.HAZARD__OWNER:
                return basicGetOwner() != null;
            case STAMPPackage.HAZARD__SAFETY_CONSTRAINT:
                return safetyConstraints != null && !safetyConstraints.isEmpty();
            case STAMPPackage.HAZARD__ACCIDENT:
                return accidents != null && !accidents.isEmpty();
        }
        return eDynamicIsSet(featureID);
    }

} //HazardImpl
