/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;

import net.astah.stpa.stamp.Accident;
import net.astah.stpa.stamp.ControlStructure;
import net.astah.stpa.stamp.Countermeasure;
import net.astah.stpa.stamp.HCFAnalysis;
import net.astah.stpa.stamp.HCFHintWordSet;
import net.astah.stpa.stamp.Hazard;
import net.astah.stpa.stamp.HazardCausalFactor;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.Precondition;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.STPAAnalysis;
import net.astah.stpa.stamp.SafetyConstraint;
import net.astah.stpa.stamp.UCAAnalysis;
import net.astah.stpa.stamp.UCAGuideWordSet;

import net.astah.stpa.stamp.UnsafeControlAction;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>STPA Analysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getAccidents <em>Accident</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getHazards <em>Hazard</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getSafetyConstraints <em>Safety Constraint</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getPreconditions <em>Precondition</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getControlStructures <em>Control Structure</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getCountermeasures <em>Countermeasure</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getHazardCausalFactors <em>Hazard Causal Factor</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getUnsafeControlActions <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getUCAGuideWordSets <em>UCA Guide Word Set</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getHCFHintWordSets <em>HCF Hint Word Set</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getOwner <em>Owner</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getUcaAnalysis <em>Uca Analysis</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.STPAAnalysisImpl#getHcfAnalysis <em>Hcf Analysis</em>}</li>
 * </ul>
 *
 * @generated
 */
public class STPAAnalysisImpl extends NamedElementImpl implements STPAAnalysis {
    /**
     * The cached value of the '{@link #getAccidents() <em>Accident</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getAccidents()
     * @generated
     * @ordered
     */
    protected EList<Accident> accidents;

    /**
     * The cached value of the '{@link #getHazards() <em>Hazard</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHazards()
     * @generated
     * @ordered
     */
    protected EList<Hazard> hazards;

    /**
     * The cached value of the '{@link #getSafetyConstraints() <em>Safety Constraint</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSafetyConstraints()
     * @generated
     * @ordered
     */
    protected EList<SafetyConstraint> safetyConstraints;

    /**
     * The cached value of the '{@link #getPreconditions() <em>Precondition</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getPreconditions()
     * @generated
     * @ordered
     */
    protected EList<Precondition> preconditions;

    /**
     * The cached value of the '{@link #getControlStructures() <em>Control Structure</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getControlStructures()
     * @generated
     * @ordered
     */
    protected EList<ControlStructure> controlStructures;

    /**
     * The cached value of the '{@link #getCountermeasures() <em>Countermeasure</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getCountermeasures()
     * @generated
     * @ordered
     */
    protected EList<Countermeasure> countermeasures;

    /**
     * The cached value of the '{@link #getHazardCausalFactors() <em>Hazard Causal Factor</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHazardCausalFactors()
     * @generated
     * @ordered
     */
    protected EList<HazardCausalFactor> hazardCausalFactors;

    /**
     * The cached value of the '{@link #getUnsafeControlActions() <em>Unsafe Control Action</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUnsafeControlActions()
     * @generated
     * @ordered
     */
    protected EList<UnsafeControlAction> unsafeControlActions;

    /**
     * The cached value of the '{@link #getUCAGuideWordSets() <em>UCA Guide Word Set</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUCAGuideWordSets()
     * @generated
     * @ordered
     */
    protected EList<UCAGuideWordSet> uCAGuideWordSets;

    /**
     * The cached value of the '{@link #getHCFHintWordSets() <em>HCF Hint Word Set</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHCFHintWordSets()
     * @generated
     * @ordered
     */
    protected EList<HCFHintWordSet> hCFHintWordSets;

    /**
     * The cached value of the '{@link #getOwner() <em>Owner</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getOwner()
     * @generated
     * @ordered
     */
    protected EObject owner;

    /**
     * The cached value of the '{@link #getUcaAnalysis() <em>Uca Analysis</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUcaAnalysis()
     * @generated
     * @ordered
     */
    protected UCAAnalysis ucaAnalysis;

    /**
     * The cached value of the '{@link #getHcfAnalysis() <em>Hcf Analysis</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getHcfAnalysis()
     * @generated
     * @ordered
     */
    protected HCFAnalysis hcfAnalysis;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected STPAAnalysisImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.STPA_ANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Accident> getAccidents() {
        if (accidents == null) {
            accidents = new EObjectContainmentWithInverseEList.Resolving<Accident>(Accident.class, this, STAMPPackage.STPA_ANALYSIS__ACCIDENT, STAMPPackage.ACCIDENT__OWNER);
        }
        return accidents;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Accident createAccident() {
        Accident newAccident = (Accident) create(STAMPPackage.Literals.ACCIDENT);
        getAccidents().add(newAccident);
        return newAccident;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Hazard> getHazards() {
        if (hazards == null) {
            hazards = new EObjectContainmentWithInverseEList.Resolving<Hazard>(Hazard.class, this, STAMPPackage.STPA_ANALYSIS__HAZARD, STAMPPackage.HAZARD__OWNER);
        }
        return hazards;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Hazard createHazard() {
        Hazard newHazard = (Hazard) create(STAMPPackage.Literals.HAZARD);
        getHazards().add(newHazard);
        return newHazard;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<SafetyConstraint> getSafetyConstraints() {
        if (safetyConstraints == null) {
            safetyConstraints = new EObjectContainmentWithInverseEList.Resolving<SafetyConstraint>(SafetyConstraint.class, this, STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT, STAMPPackage.SAFETY_CONSTRAINT__OWNER);
        }
        return safetyConstraints;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SafetyConstraint createSafetyConstraint() {
        SafetyConstraint newSafetyConstraint = (SafetyConstraint) create(STAMPPackage.Literals.SAFETY_CONSTRAINT);
        getSafetyConstraints().add(newSafetyConstraint);
        return newSafetyConstraint;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Precondition> getPreconditions() {
        if (preconditions == null) {
            preconditions = new EObjectContainmentWithInverseEList.Resolving<Precondition>(Precondition.class, this, STAMPPackage.STPA_ANALYSIS__PRECONDITION, STAMPPackage.PRECONDITION__OWNER);
        }
        return preconditions;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Precondition createPrecondition() {
        Precondition newPrecondition = (Precondition) create(STAMPPackage.Literals.PRECONDITION);
        getPreconditions().add(newPrecondition);
        return newPrecondition;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Countermeasure> getCountermeasures() {
        if (countermeasures == null) {
            countermeasures = new EObjectContainmentWithInverseEList.Resolving<Countermeasure>(Countermeasure.class, this, STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE, STAMPPackage.COUNTERMEASURE__OWNER);
        }
        return countermeasures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Countermeasure createCountermeasure() {
        Countermeasure newCountermeasure = (Countermeasure) create(STAMPPackage.Literals.COUNTERMEASURE);
        getCountermeasures().add(newCountermeasure);
        return newCountermeasure;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<UCAGuideWordSet> getUCAGuideWordSets() {
        if (uCAGuideWordSets == null) {
            uCAGuideWordSets = new EObjectContainmentWithInverseEList.Resolving<UCAGuideWordSet>(UCAGuideWordSet.class, this, STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET, STAMPPackage.UCA_GUIDE_WORD_SET__OWNER);
        }
        return uCAGuideWordSets;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAGuideWordSet createUCAGuideWordSet() {
        UCAGuideWordSet newUCAGuideWordSet = (UCAGuideWordSet) create(STAMPPackage.Literals.UCA_GUIDE_WORD_SET);
        getUCAGuideWordSets().add(newUCAGuideWordSet);
        return newUCAGuideWordSet;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<HCFHintWordSet> getHCFHintWordSets() {
        if (hCFHintWordSets == null) {
            hCFHintWordSets = new EObjectContainmentWithInverseEList.Resolving<HCFHintWordSet>(HCFHintWordSet.class, this, STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET, STAMPPackage.HCF_HINT_WORD_SET__OWNER);
        }
        return hCFHintWordSets;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFHintWordSet createHCFHintWordSet() {
        HCFHintWordSet newHCFHintWordSet = (HCFHintWordSet) create(STAMPPackage.Literals.HCF_HINT_WORD_SET);
        getHCFHintWordSets().add(newHCFHintWordSet);
        return newHCFHintWordSet;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EObject getOwner() {
        if (owner != null && owner.eIsProxy()) {
            InternalEObject oldOwner = (InternalEObject)owner;
            owner = eResolveProxy(oldOwner);
            if (owner != oldOwner) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.STPA_ANALYSIS__OWNER, oldOwner, owner));
            }
        }
        return owner;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EObject basicGetOwner() {
        return owner;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setOwner(EObject newOwner) {
        EObject oldOwner = owner;
        owner = newOwner;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.STPA_ANALYSIS__OWNER, oldOwner, owner));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysis getUcaAnalysis() {
        if (ucaAnalysis != null && ucaAnalysis.eIsProxy()) {
            InternalEObject oldUcaAnalysis = (InternalEObject)ucaAnalysis;
            ucaAnalysis = (UCAAnalysis)eResolveProxy(oldUcaAnalysis);
            if (ucaAnalysis != oldUcaAnalysis) {
                InternalEObject newUcaAnalysis = (InternalEObject)ucaAnalysis;
                NotificationChain msgs =  oldUcaAnalysis.eInverseRemove(this, STAMPPackage.UCA_ANALYSIS__OWNER, UCAAnalysis.class, null);
                if (newUcaAnalysis.eInternalContainer() == null) {
                    msgs =  newUcaAnalysis.eInverseAdd(this, STAMPPackage.UCA_ANALYSIS__OWNER, UCAAnalysis.class, msgs);
                }
                if (msgs != null) msgs.dispatch();
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS, oldUcaAnalysis, ucaAnalysis));
            }
        }
        return ucaAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysis basicGetUcaAnalysis() {
        return ucaAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetUcaAnalysis(UCAAnalysis newUcaAnalysis, NotificationChain msgs) {
        UCAAnalysis oldUcaAnalysis = ucaAnalysis;
        ucaAnalysis = newUcaAnalysis;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS, oldUcaAnalysis, newUcaAnalysis);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setUcaAnalysis(UCAAnalysis newUcaAnalysis) {
        if (newUcaAnalysis != ucaAnalysis) {
            NotificationChain msgs = null;
            if (ucaAnalysis != null)
                msgs = ((InternalEObject)ucaAnalysis).eInverseRemove(this, STAMPPackage.UCA_ANALYSIS__OWNER, UCAAnalysis.class, msgs);
            if (newUcaAnalysis != null)
                msgs = ((InternalEObject)newUcaAnalysis).eInverseAdd(this, STAMPPackage.UCA_ANALYSIS__OWNER, UCAAnalysis.class, msgs);
            msgs = basicSetUcaAnalysis(newUcaAnalysis, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS, newUcaAnalysis, newUcaAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAAnalysis createUcaAnalysis() {
        UCAAnalysis newUcaAnalysis = (UCAAnalysis) create(STAMPPackage.Literals.UCA_ANALYSIS);
        setUcaAnalysis(newUcaAnalysis);
        return newUcaAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<UnsafeControlAction> getUnsafeControlActions() {
        if (unsafeControlActions == null) {
            unsafeControlActions = new EObjectContainmentWithInverseEList.Resolving<UnsafeControlAction>(UnsafeControlAction.class, this, STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION, STAMPPackage.UNSAFE_CONTROL_ACTION__OWNER);
        }
        return unsafeControlActions;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UnsafeControlAction createUnsafeControlAction() {
        UnsafeControlAction newUnsafeControlAction = (UnsafeControlAction) create(STAMPPackage.Literals.UNSAFE_CONTROL_ACTION);
        getUnsafeControlActions().add(newUnsafeControlAction);
        return newUnsafeControlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFAnalysis getHcfAnalysis() {
        if (hcfAnalysis != null && hcfAnalysis.eIsProxy()) {
            InternalEObject oldHcfAnalysis = (InternalEObject)hcfAnalysis;
            hcfAnalysis = (HCFAnalysis)eResolveProxy(oldHcfAnalysis);
            if (hcfAnalysis != oldHcfAnalysis) {
                InternalEObject newHcfAnalysis = (InternalEObject)hcfAnalysis;
                NotificationChain msgs =  oldHcfAnalysis.eInverseRemove(this, STAMPPackage.HCF_ANALYSIS__OWNER, HCFAnalysis.class, null);
                if (newHcfAnalysis.eInternalContainer() == null) {
                    msgs =  newHcfAnalysis.eInverseAdd(this, STAMPPackage.HCF_ANALYSIS__OWNER, HCFAnalysis.class, msgs);
                }
                if (msgs != null) msgs.dispatch();
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS, oldHcfAnalysis, hcfAnalysis));
            }
        }
        return hcfAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFAnalysis basicGetHcfAnalysis() {
        return hcfAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetHcfAnalysis(HCFAnalysis newHcfAnalysis, NotificationChain msgs) {
        HCFAnalysis oldHcfAnalysis = hcfAnalysis;
        hcfAnalysis = newHcfAnalysis;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS, oldHcfAnalysis, newHcfAnalysis);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setHcfAnalysis(HCFAnalysis newHcfAnalysis) {
        if (newHcfAnalysis != hcfAnalysis) {
            NotificationChain msgs = null;
            if (hcfAnalysis != null)
                msgs = ((InternalEObject)hcfAnalysis).eInverseRemove(this, STAMPPackage.HCF_ANALYSIS__OWNER, HCFAnalysis.class, msgs);
            if (newHcfAnalysis != null)
                msgs = ((InternalEObject)newHcfAnalysis).eInverseAdd(this, STAMPPackage.HCF_ANALYSIS__OWNER, HCFAnalysis.class, msgs);
            msgs = basicSetHcfAnalysis(newHcfAnalysis, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS, newHcfAnalysis, newHcfAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HCFAnalysis createHcfAnalysis() {
        HCFAnalysis newHcfAnalysis = (HCFAnalysis) create(STAMPPackage.Literals.HCF_ANALYSIS);
        setHcfAnalysis(newHcfAnalysis);
        return newHcfAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<HazardCausalFactor> getHazardCausalFactors() {
        if (hazardCausalFactors == null) {
            hazardCausalFactors = new EObjectContainmentWithInverseEList.Resolving<HazardCausalFactor>(HazardCausalFactor.class, this, STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR, STAMPPackage.HAZARD_CAUSAL_FACTOR__OWNER);
        }
        return hazardCausalFactors;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public HazardCausalFactor createHazardCausalFactor() {
        HazardCausalFactor newHazardCausalFactor = (HazardCausalFactor) create(STAMPPackage.Literals.HAZARD_CAUSAL_FACTOR);
        getHazardCausalFactors().add(newHazardCausalFactor);
        return newHazardCausalFactor;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ControlStructure> getControlStructures() {
        if (controlStructures == null) {
            controlStructures = new EObjectContainmentWithInverseEList.Resolving<ControlStructure>(ControlStructure.class, this, STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE, STAMPPackage.CONTROL_STRUCTURE__OWNER);
        }
        return controlStructures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlStructure createControlStructure() {
        ControlStructure newControlStructure = (ControlStructure) create(STAMPPackage.Literals.CONTROL_STRUCTURE);
        getControlStructures().add(newControlStructure);
        return newControlStructure;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getAccidents()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getHazards()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getSafetyConstraints()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getPreconditions()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getControlStructures()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getCountermeasures()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getHazardCausalFactors()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getUnsafeControlActions()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getUCAGuideWordSets()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getHCFHintWordSets()).basicAdd(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                if (ucaAnalysis != null)
                    msgs = ((InternalEObject)ucaAnalysis).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS, null, msgs);
                return basicSetUcaAnalysis((UCAAnalysis)otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                if (hcfAnalysis != null)
                    msgs = ((InternalEObject)hcfAnalysis).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS, null, msgs);
                return basicSetHcfAnalysis((HCFAnalysis)otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                return ((InternalEList<?>)getAccidents()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                return ((InternalEList<?>)getHazards()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                return ((InternalEList<?>)getSafetyConstraints()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                return ((InternalEList<?>)getPreconditions()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                return ((InternalEList<?>)getControlStructures()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                return ((InternalEList<?>)getCountermeasures()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                return ((InternalEList<?>)getHazardCausalFactors()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                return ((InternalEList<?>)getUnsafeControlActions()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                return ((InternalEList<?>)getUCAGuideWordSets()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                return ((InternalEList<?>)getHCFHintWordSets()).basicRemove(otherEnd, msgs);
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                return basicSetUcaAnalysis(null, msgs);
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                return basicSetHcfAnalysis(null, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.STPA_ANALYSIS__NAME:
                return getName();
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                return getAccidents();
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                return getHazards();
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                return getSafetyConstraints();
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                return getPreconditions();
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                return getControlStructures();
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                return getCountermeasures();
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                return getHazardCausalFactors();
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                return getUnsafeControlActions();
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                return getUCAGuideWordSets();
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                return getHCFHintWordSets();
            case STAMPPackage.STPA_ANALYSIS__OWNER:
                if (resolve) return getOwner();
                return basicGetOwner();
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                if (resolve) return getUcaAnalysis();
                return basicGetUcaAnalysis();
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                if (resolve) return getHcfAnalysis();
                return basicGetHcfAnalysis();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__NAME:
                setName((String)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                getAccidents().clear();
                getAccidents().addAll((Collection<? extends Accident>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                getHazards().clear();
                getHazards().addAll((Collection<? extends Hazard>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                getSafetyConstraints().clear();
                getSafetyConstraints().addAll((Collection<? extends SafetyConstraint>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                getPreconditions().clear();
                getPreconditions().addAll((Collection<? extends Precondition>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                getControlStructures().clear();
                getControlStructures().addAll((Collection<? extends ControlStructure>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                getCountermeasures().clear();
                getCountermeasures().addAll((Collection<? extends Countermeasure>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                getHazardCausalFactors().clear();
                getHazardCausalFactors().addAll((Collection<? extends HazardCausalFactor>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                getUnsafeControlActions().clear();
                getUnsafeControlActions().addAll((Collection<? extends UnsafeControlAction>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                getUCAGuideWordSets().clear();
                getUCAGuideWordSets().addAll((Collection<? extends UCAGuideWordSet>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                getHCFHintWordSets().clear();
                getHCFHintWordSets().addAll((Collection<? extends HCFHintWordSet>)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__OWNER:
                setOwner((EObject)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                setUcaAnalysis((UCAAnalysis)newValue);
                return;
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                setHcfAnalysis((HCFAnalysis)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__NAME:
                setName(NAME_EDEFAULT);
                return;
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                getAccidents().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                getHazards().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                getSafetyConstraints().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                getPreconditions().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                getControlStructures().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                getCountermeasures().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                getHazardCausalFactors().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                getUnsafeControlActions().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                getUCAGuideWordSets().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                getHCFHintWordSets().clear();
                return;
            case STAMPPackage.STPA_ANALYSIS__OWNER:
                setOwner((EObject)null);
                return;
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                setUcaAnalysis((UCAAnalysis)null);
                return;
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                setHcfAnalysis((HCFAnalysis)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.STPA_ANALYSIS__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__OWNED_NOTE:
                return ownedNotes != null && !ownedNotes.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__NAME:
                return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
            case STAMPPackage.STPA_ANALYSIS__ACCIDENT:
                return accidents != null && !accidents.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__HAZARD:
                return hazards != null && !hazards.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__SAFETY_CONSTRAINT:
                return safetyConstraints != null && !safetyConstraints.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__PRECONDITION:
                return preconditions != null && !preconditions.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__CONTROL_STRUCTURE:
                return controlStructures != null && !controlStructures.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__COUNTERMEASURE:
                return countermeasures != null && !countermeasures.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__HAZARD_CAUSAL_FACTOR:
                return hazardCausalFactors != null && !hazardCausalFactors.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__UNSAFE_CONTROL_ACTION:
                return unsafeControlActions != null && !unsafeControlActions.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__UCA_GUIDE_WORD_SET:
                return uCAGuideWordSets != null && !uCAGuideWordSets.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__HCF_HINT_WORD_SET:
                return hCFHintWordSets != null && !hCFHintWordSets.isEmpty();
            case STAMPPackage.STPA_ANALYSIS__OWNER:
                return owner != null;
            case STAMPPackage.STPA_ANALYSIS__UCA_ANALYSIS:
                return ucaAnalysis != null;
            case STAMPPackage.STPA_ANALYSIS__HCF_ANALYSIS:
                return hcfAnalysis != null;
        }
        return eDynamicIsSet(featureID);
    }

} //STPAAnalysisImpl
