/**
 */
package net.astah.stpa.stamp.impl;

import java.util.Collection;

import net.astah.stpa.stamp.ControlAction;
import net.astah.stpa.stamp.Element;
import net.astah.stpa.stamp.Note;
import net.astah.stpa.stamp.STAMPPackage;
import net.astah.stpa.stamp.UCAAnalysisResult;
import net.astah.stpa.stamp.UCAGuideWord;
import net.astah.stpa.stamp.UnsafeControlAction;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.SubsetSupersetEObjectContainmentWithInverseEList;
import org.eclipse.uml2.common.util.SubsetSupersetEObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>UCA Analysis Result</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.impl.UCAAnalysisResultImpl#getResultElements <em>Result Element</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UCAAnalysisResultImpl#getUnsafeControlActions <em>Unsafe Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UCAAnalysisResultImpl#getControlAction <em>Control Action</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UCAAnalysisResultImpl#getGuideWord <em>Guide Word</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.impl.UCAAnalysisResultImpl#getOwnedNotes <em>Owned Note</em>}</li>
 * </ul>
 *
 * @generated
 */
public class UCAAnalysisResultImpl extends ElementImpl implements UCAAnalysisResult {
    /**
     * The cached value of the '{@link #getResultElements() <em>Result Element</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getResultElements()
     * @generated
     * @ordered
     */
    protected EList<Element> resultElements;
    /**
     * The cached value of the '{@link #getUnsafeControlActions() <em>Unsafe Control Action</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUnsafeControlActions()
     * @generated
     * @ordered
     */
    protected EList<UnsafeControlAction> unsafeControlActions;
    /**
     * The cached value of the '{@link #getControlAction() <em>Control Action</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getControlAction()
     * @generated
     * @ordered
     */
    protected ControlAction controlAction;
    /**
     * The cached value of the '{@link #getGuideWord() <em>Guide Word</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getGuideWord()
     * @generated
     * @ordered
     */
    protected UCAGuideWord guideWord;
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected UCAAnalysisResultImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPPackage.Literals.UCA_ANALYSIS_RESULT;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Element> getResultElements() {
        if (resultElements == null) {
            resultElements = new SubsetSupersetEObjectResolvingEList<Element>(Element.class, this, STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT, null, RESULT_ELEMENT_ESUBSETS);
        }
        return resultElements;
    }

    /**
     * The array of subset feature identifiers for the '{@link #getResultElements() <em>Result Element</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getResultElements()
     * @generated
     * @ordered
     */
    protected static final int[] RESULT_ELEMENT_ESUBSETS = new int[] {STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE};
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<UnsafeControlAction> getUnsafeControlActions() {
        if (unsafeControlActions == null) {
            unsafeControlActions = new SubsetSupersetEObjectResolvingEList<UnsafeControlAction>(UnsafeControlAction.class, this, STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION, UNSAFE_CONTROL_ACTION_ESUPERSETS, null);
        }
        return unsafeControlActions;
    }

    /**
     * The array of superset feature identifiers for the '{@link #getUnsafeControlActions() <em>Unsafe Control Action</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getUnsafeControlActions()
     * @generated
     * @ordered
     */
    protected static final int[] UNSAFE_CONTROL_ACTION_ESUPERSETS = new int[] {STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT};
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlAction getControlAction() {
        if (controlAction != null && controlAction.eIsProxy()) {
            InternalEObject oldControlAction = (InternalEObject)controlAction;
            controlAction = (ControlAction)eResolveProxy(oldControlAction);
            if (controlAction != oldControlAction) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION, oldControlAction, controlAction));
            }
        }
        return controlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ControlAction basicGetControlAction() {
        return controlAction;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setControlAction(ControlAction newControlAction) {
        ControlAction oldControlAction = controlAction;
        controlAction = newControlAction;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION, oldControlAction, controlAction));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAGuideWord getGuideWord() {
        if (guideWord != null && guideWord.eIsProxy()) {
            InternalEObject oldGuideWord = (InternalEObject)guideWord;
            guideWord = (UCAGuideWord)eResolveProxy(oldGuideWord);
            if (guideWord != oldGuideWord) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD, oldGuideWord, guideWord));
            }
        }
        return guideWord;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public UCAGuideWord basicGetGuideWord() {
        return guideWord;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setGuideWord(UCAGuideWord newGuideWord) {
        UCAGuideWord oldGuideWord = guideWord;
        guideWord = newGuideWord;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD, oldGuideWord, guideWord));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<Note> getOwnedNotes() {
        if (ownedNotes == null) {
            ownedNotes = new SubsetSupersetEObjectContainmentWithInverseEList.Resolving<Note>(Note.class, this, STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE, OWNED_NOTE_ESUPERSETS, null, STAMPPackage.NOTE__OWNER);
        }
        return ownedNotes;
    }

    /**
     * The array of superset feature identifiers for the '{@link #getOwnedNotes() <em>Owned Note</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getOwnedNotes()
     * @generated
     * @ordered
     */
    protected static final int[] OWNED_NOTE_ESUPERSETS = new int[] {STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT};
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Note createOwnedNote() {
        Note newOwnedNote = (Note) create(STAMPPackage.Literals.NOTE);
        getOwnedNotes().add(newOwnedNote);
        return newOwnedNote;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetOwnedNotes() {
        return ownedNotes != null && !ownedNotes.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOwnedNotes()).basicAdd(otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                return ((InternalEList<?>)getOwnedNotes()).basicRemove(otherEnd, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                return getEAnnotations();
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                return getOwnedNotes();
            case STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT:
                return getResultElements();
            case STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                return getUnsafeControlActions();
            case STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION:
                if (resolve) return getControlAction();
                return basicGetControlAction();
            case STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD:
                if (resolve) return getGuideWord();
                return basicGetGuideWord();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                getOwnedNotes().clear();
                getOwnedNotes().addAll((Collection<? extends Note>)newValue);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT:
                getResultElements().clear();
                getResultElements().addAll((Collection<? extends Element>)newValue);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                getUnsafeControlActions().clear();
                getUnsafeControlActions().addAll((Collection<? extends UnsafeControlAction>)newValue);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION:
                setControlAction((ControlAction)newValue);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD:
                setGuideWord((UCAGuideWord)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                getOwnedNotes().clear();
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT:
                getResultElements().clear();
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                getUnsafeControlActions().clear();
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION:
                setControlAction((ControlAction)null);
                return;
            case STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD:
                setGuideWord((UCAGuideWord)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPPackage.UCA_ANALYSIS_RESULT__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPPackage.UCA_ANALYSIS_RESULT__OWNED_NOTE:
                return isSetOwnedNotes();
            case STAMPPackage.UCA_ANALYSIS_RESULT__RESULT_ELEMENT:
                return resultElements != null && !resultElements.isEmpty();
            case STAMPPackage.UCA_ANALYSIS_RESULT__UNSAFE_CONTROL_ACTION:
                return unsafeControlActions != null && !unsafeControlActions.isEmpty();
            case STAMPPackage.UCA_ANALYSIS_RESULT__CONTROL_ACTION:
                return controlAction != null;
            case STAMPPackage.UCA_ANALYSIS_RESULT__GUIDE_WORD:
                return guideWord != null;
        }
        return eDynamicIsSet(featureID);
    }

} //UCAAnalysisResultImpl
